local ACTIVITY_INDICATOR_ROTATION_SPEED = 1 / 10

local function Start (impl)
  if impl.activity_indicator_action then return end

  impl.activity_indicator_action = StartPeriodicCall (impl.timer, ACTIVITY_INDICATOR_ROTATION_SPEED, function ()
    impl.activity_indicator:Rotate (0, 0, -45)
  end)
end

local function Stop (impl)
  if not impl.activity_indicator_action then return end
  
  impl.activity_indicator_action.Stop ()
  impl.activity_indicator_action = nil
end

function CreateActivityIndicator (size, timer, scale_inherit)
  local impl = {}

  impl.timer = timer or "default"

  impl.activity_indicator = Scene.Sprite.Create ()

  impl.activity_indicator.Scale        = vec3 (size, size, 1)
  impl.activity_indicator.ScaleInherit = scale_inherit
  impl.activity_indicator.Material     = "activity_indicator"

  Start (impl)    

  local public_methods = {}

  public_methods.GetSprite = function () return impl.activity_indicator end
  public_methods.Start     = function () Start (impl) end
  public_methods.Stop      = function () Stop (impl) end
    
  return public_methods
end
