function BonusDeactivateWindow (sprites, textlines)
  for key, sprite in pairs (sprites) do
    if GetSprite (sprite) then
      DeactivateSprite (sprite)
    end
  end
  for key, tl in pairs (textlines) do
    if GetTextLine (sprite) then
      DeactivateTextLine (tl)
    end
  end
end

function BonusActivateWindow (sprites, deactivate_sprites, textlines)
  for key, sprite in pairs (sprites) do
    if GetSprite (sprite) then
      ActivateSprite (sprite)
    end
  end
  for key, tl in pairs (textlines) do
    if GetTextLine (tl) then
      ActivateTextLine (tl)
    end
  end
  if deactivate_sprites then
    for key, sprite in pairs (deactivate_sprites) do
      if GetSprite (sprite) then
        DeactivateSprite (sprite)
      end
    end
  end
end

function BonusShowWindowByAlphaNoBloker (sprites, deactivate_sprites, textlines, show_time, OnShow)
  for key, tl in pairs (textlines) do
    if GetTextLine (tl) then
      ActivateTextLine (tl)
      local color = GetTextLine (tl).node.Color
      color.w = 0
      GetTextLine (tl).node.Color = color
      color.w = 1
      ChangeSpriteColorSlowly ("default", GetTextLine (tl), color, show_time, nil)    


     if GetTextLine (tl).stroked_text_line then
        local color = GetTextLine (tl).stroked_text_line.Color
        color.w = 0
        GetTextLine (tl).stroked_text_line.Color = color
        color.w = 1
        ChangeSpriteColorSlowly ("default", GetTextLine (tl).stroked_text_line, color, show_time) 
      end
    end
  end
  for key, sprite in pairs (sprites) do
    if GetSprite (sprite) then
      ActivateSprite (sprite)
      local color = GetSprite (sprite).node.Color
      color.w = 0
      GetSprite (sprite).node.Color = color
      color.w = 1
      ChangeSpriteColorSlowly ("default", GetSprite (sprite), color, show_time, nil)    
    end
  end
  if deactivate_sprites then
    for key, sprite in pairs (deactivate_sprites) do
      if GetSprite (sprite) then
        DeactivateSprite (sprite)
      end
    end
  end
end

function BonusShowWindowByAlpha (sprites, deactivate_sprites, textlines, show_time, OnShow)

  BonusShowWindowByAlphaNoBloker (sprites, deactivate_sprites, textlines, show_time, OnShow)
    
  DelayedAction("default", show_time,
    function (t)
      ActivateSprite ('blocker')
      if OnShow then
        OnShow ()
      end
    end);
    
end

function BonusHideWindowByAlpha (sprites, textlines, show_time, OnHide)
  SetInputState (false)
  for key, sprite in pairs (sprites) do
    if GetSprite (sprite) then
      local color = GetSprite (sprite).node.Color
      color.w = 0
      ChangeSpriteColorSlowly ("default", GetSprite (sprite), color, show_time,
      function ()
        DeactivateSprite (sprite)
      end) 
    end
  end
  for key, tl in pairs (textlines) do
    if GetTextLine (tl) then
      local color = GetTextLine (tl).node.Color
      color.w = 0
      ChangeSpriteColorSlowly ("default", GetTextLine (tl), color, show_time,
      function ()
        DeactivateTextLine (tl)
      end) 
      if GetTextLine (tl).stroked_text_line then
        local color = GetTextLine (tl).stroked_text_line.Color
        color.w = 0
        ChangeSpriteColorSlowly ("default", GetTextLine (tl).stroked_text_line, color, show_time) 
      end 
    end
  end
  
  DelayedAction ("default", show_time,
    function (t)
      BonusDeactivateWindow (sprites, textlines)
      DeactivateSprite ('blocker')
      SetInputState (true)
      if OnHide then
        OnHide ()
      end
    end);

  DeactivateSprite ('blocker')
end
