local ANDROID_APPLICATION_KEY = "2Z3TRQ2VC75HHF9PK6GB"
local IOS_APPLICATION_KEY     = "C27ZY4VQSPSW8X4QKVM3"

local is_supported

function LogFlurryEvent (event, params, add_social_network_info)
  params = params or {}
  
  if add_social_network_info then
    params.NetworkName = GetSocialManager ().GetNetworkName ()
    
    if GetSocialManager ().IsInGuestMode () then
      event = "guest_" .. event
    else
      event = "auth_" .. event
    end
  end
  
  local params_map = Common.PropertyMap.Create ()
  
  local params_string = ""
  
  for key, value in pairs (params) do
    params_map:SetString (tostring (key), tostring (value))
    
    if DEBUG then
      params_string = params_string .. " / " .. tostring (key) .. " = " ..  tostring (value)
    end
  end
  
  if DEBUG then
    print ("LogFlurryEvent ***" .. event .. "*** with params ***" .. params_string .. "***")
  end

  if not is_supported then return end
  
  Analytics.Flurry.LogEvent (event, params_map)
end

function InitFlurry ()
  is_supported = Analytics.Flurry.IsSupported
  
  if GetHsPort () ~= HS_LIVE_PORT then  -- do not track events on dev devices
    print ("Flurry analytics disabled, not live connection")
    is_supported = false
  end
  
  if not is_supported then return end

  local application_key

  local os = ApplicationDataGet (OS_TYPE)

  if os == "iOS" then
    application_key = IOS_APPLICATION_KEY
  elseif os == "Android" then
    application_key = ANDROID_APPLICATION_KEY
  end
  
  if not application_key then
    print ("WARNING: Flurry analytics supported on this platform, but no Application Key specified")
    return
  end

  Analytics.Flurry.StartSession (application_key)
end
