local BATTLE_OPPONENT_UPDATE_DELAY                   = 5
local BATTLE_OVERLAY_SCORE_VALUE_PHONE_SYMBOLS_COUNT = 7
local BATTLE_OVERLAY_SCORE_VALUE_PAD_SYMBOLS_COUNT   = 9
local BATTLE_OVERLAY_USER_SCORE_VALUE_SYMBOLS_COUNT  = 10
local BATTLE_PROGRESS_UPDATE_DURATION    = 0.75
local BOTTOM_PANEL_HIDE_DURATION         = 0.125
local DIAMOND_ANIMATION_DURATION         = 0.5
local DRAG_THRESHOLD                     = 10
local EPS                                = 0.0001
local FONT                               = "data/fonts/MyriadPro-BoldCond.xfont"
local HIGHLIGHT_PERIOD                   = 0.5
local HIGHLIGHT_HALF_PERIOD              = HIGHLIGHT_PERIOD / 2
local LINE_ANIMATION_DURATION            = 2
local LINE_ANIMATION_PERIOD              = 0.5
local LONG_PRESS_DURATION                = 2
local FREE_SPINS_LINE_ANIMATION_DURATION = 1
local PHOTO_ACTIVITY_INDICATOR_FACTOR    = 0.4
local SHOW_BATTLE_RESULTS_DELAY          = 1
local STROKED_FONT                       = "data/fonts/MyriadPro-BoldCond-stroked.xfont"
local SYMBOLS_GROUP_SIZE                 = 20
local PAD_TOTAL_BET_MAX_SYMBOLS_COUNT    = 10
local PHONE_TOTAL_BET_MAX_SYMBOLS_COUNT  = 7
local PAD_PAYOUT_MAX_SYMBOLS_COUNT       = 10
local PHONE_PAYOUT_MAX_SYMBOLS_COUNT     = 11
local WINTABLE_LINE_DIGITS_COUNT         = 7

local LINES_SYMBOLS = {
  { 5, 6, 7, 8, 9 },           --1
  { 0, 1, 2, 3, 4 },           --2
  { 10, 11, 12, 13, 14 },      --3
  { 0, 6, 12, 8, 4 },          --4
  { 10, 6, 2, 8, 14 },         --5
  { 5, 1, 2, 3, 9 },           --6
  { 5, 11, 12, 13, 9 },        --7
  { 0, 1, 7, 13, 14 },         --8
  { 10, 11, 7, 3, 4 },         --9
  { 5, 11, 7, 3, 9 },          --10
  { 5, 1, 7, 13, 9 },          --11
  { 0, 6, 7, 8, 4 },           --12
  { 10, 6, 7, 8, 14 },         --13
  { 0, 6, 2, 8, 4 },           --14
  { 10, 6, 12, 8, 14 },        --15
  { 5, 6, 2, 8, 9 },           --16
  { 5, 6, 12, 8, 9 },          --17
  { 0, 1, 12, 3, 4 },          --18
  { 10, 11, 2, 13, 14 },       --19
  { 0, 11, 12, 13, 4 },        --20
  { 10, 1, 2, 3, 14 },         --21
  { 5, 11, 2, 13, 9 },         --22
  { 5, 1, 12, 3, 9 },          --23
  { 0, 11, 2, 13, 4 },         --24
  { 10, 1, 12, 3, 14 },        --25
  { 10, 1, 7, 13, 4 },         --26
  { 0, 11, 7, 3, 14 },         --27
  { 0, 11, 7, 13, 4 },         --28
  { 10, 1, 7, 3, 14 },         --29
  { 10, 6, 2, 3, 9 },          --30
  { 0, 6, 12, 13, 9 },         --31
  { 0, 1, 12, 13, 14 },        --32
  { 10, 11, 2, 3, 4 },         --33
  { 5, 1, 12, 8, 14 },         --34
  { 5, 11, 2, 8, 4 },          --35
  { 0, 6, 2, 8, 14 },          --36
  { 10, 6, 12, 8, 4 },         --37
  { 5, 11, 12, 3, 4 },         --38
  { 0, 1, 7, 8, 14 },          --39
  { 10, 11, 7, 8, 4 },         --40
  { 10, 1, 2, 3, 4 },          --41
  { 0, 11, 12, 13, 14 },       --42
  { 10, 11, 12, 13, 4 },       --43
  { 0, 1, 2, 3, 14 },          --44
  { 5, 1, 7, 3, 9 },           --45
  { 5, 11, 7, 13, 9 },         --46
  { 0, 6, 12, 13, 14 },        --47
  { 10, 6, 2, 3, 4 },          --48
  { 0, 6, 7, 8, 9 },           --49
  { 10, 6, 7, 8, 9 },          --50
  { 0, 1, 2, 3, 9 },           --51
  { 0, 1, 2, 8, 9 },           --52
  { 0, 1, 2, 8, 14 },          --53
  { 0, 1, 7, 3, 4 },           --54
  { 0, 1, 7, 8, 4 },           --55
  { 0, 1, 7, 8, 9 },           --56
  { 0, 1, 7, 13, 9 },          --57
  { 0, 6, 2, 3, 4 },           --58
  { 0, 6, 2, 8, 9 },           --59
  { 10, 1, 7, 3, 9 },          --60
  { 0, 11, 7, 13, 9 },         --61
  { 0, 6, 2, 13, 4 },          --62
  { 10, 6, 12, 3, 14 },        --63
  { 0, 6, 7, 8, 14 },          --64
  { 10, 6, 7, 8, 4 },          --65
  { 0, 6, 7, 13, 14 },         --66
  { 5, 1, 2, 3, 4 },           --67
  { 5, 1, 2, 8, 9 },           --68
  { 5, 1, 2, 8, 14 },          --69
  { 0, 6, 7, 3, 9 },           --70
  { 5, 1, 7, 8, 14 },          --71
  { 5, 1, 7, 13, 14 },         --72
  { 5, 6, 2, 3, 4 },           --73
  { 5, 6, 2, 3, 9 },           --74
  { 5, 6, 2, 8, 14 },          --75
  { 0, 1, 12, 8, 4 },          --76
  { 5, 6, 7, 3, 4 },           --77
  { 5, 6, 12, 13, 14 },        --78
  { 10, 11, 12, 13, 9 },       --79
  { 5, 6, 7, 8, 14 },          --80
  { 0, 6, 2, 13, 9 },          --81
  { 5, 11, 12, 13, 14 },       --82
  { 5, 11, 7, 3, 4 },          --83
  { 10, 11, 7, 3, 9 },         --84
  { 10, 11, 7, 8, 9 },         --85
  { 10, 6, 12, 8, 9 },         --86
  { 0, 1, 2, 13, 4 },          --87
  { 10, 11, 12, 3, 14 },       --88
  { 10, 1, 12, 13, 14 },       --89
  { 0, 11, 2, 3, 4 },          --90
  { 10, 11, 2, 8, 14 },        --91
  { 5, 1, 7, 8, 9 },           --92
  { 5, 11, 7, 8, 9 },          --93
  { 5, 6, 12, 8, 4 },          --94
  { 10, 6, 12, 13, 14 },       --95
  { 0, 11, 7, 8, 9 },          --96
  { 10, 1, 7, 8, 9 },          --97
  { 5, 6, 7, 13, 4 },          --98
  { 5, 6, 7, 3, 14 }           --98
}

local local_methods = {}

local function OnSizeChanged (impl, window_width, window_height)
  local reference_width  = game.current_screen.vars.reference_width
  local reference_height = game.current_screen.vars.reference_height

  if impl.prev_window_width then
    if impl.prev_window_width ~= reference_width or impl.prev_window_height ~= reference_height then
      reference_width  = 0
      reference_height = 0
    end
  end

  UpdateGameCameraSize (window_width, window_height, impl.min_camera_width, impl.min_camera_height, 
                        impl.min_camera_center_x, impl.min_camera_center_y, impl.min_ar, 
                        impl.max_camera_width, impl.max_camera_height, impl.max_camera_center_x, 
                        impl.max_camera_center_y, impl.max_ar, impl.camera, reference_width, 
                        reference_height, true)

  impl.prev_window_width  = window_width
  impl.prev_window_height = window_height
end

local function OpenWinTable (impl, state, on_end_handler, user_initiated)
  if user_initiated and impl.free_spins_label_shown then return end --button disabled while free spins
  if not impl.win_table_node then return end

  if user_initiated then
    PlaySound (impl.win_table_open_click_sound)
  end

  SetSpriteActive (impl.win_close_button, state)
  SetSpriteActive (impl.win_open_button, not state)
  
  game.scripts.buttons.SetButtonActive (impl.win_close_button.name, state, true)
  game.scripts.buttons.SetButtonActive (impl.win_open_button.name, not state, true)
  
  local start_position = impl.win_table_node.Position
  local position_diff  = impl.win_table_node_position
  
  if state then 
    position_diff = position_diff + vec3 (0, impl.win_table_height, 0)
  end

  position_diff = position_diff - start_position
  
  SlowAction ("default", impl.win_table_open_duration, function (t)
    if impl.win_table_node then
      impl.win_table_node.Position = start_position + position_diff * t
    end
    
    if t == 1 and on_end_handler then
      on_end_handler ()
    end
  end)
end

local function CreateWinTableTextLine (parent, x_offset, y_offset, text, color, size, stroke_color, scissor)
  local line = Scene.TextLine.Create (game.font_library)
  
  line.Font                = FONT
  line.Text                = text
  line.Scale               = vec3 (size, size, 1)
  line.ScaleInherit        = false
  line.Color               = color
  line.HorizontalAlignment = Scene.TextLineAlignment.Center
  line.VerticalAlignment   = Scene.TextLineAlignment.BaseLine
  line.FontCreationParams  = game.font_creation_params
  line.Material            = "text_material"
  line.Scissor             = scissor
  
  line:BindToParent (parent, Scene.NodeBindMode.AddRef)

  line.WorldPosition = parent.WorldPosition + vec3 (x_offset, y_offset, -EPS)
  
  if not stroke_color then return end

  local stroked_line = Scene.TextLine.Create (game.font_library)
  
  stroked_line.Font                = STROKED_FONT
  stroked_line.Text                = text
  stroked_line.Color               = stroke_color
  stroked_line.HorizontalAlignment = Scene.TextLineAlignment.Center
  stroked_line.VerticalAlignment   = Scene.TextLineAlignment.BaseLine
  stroked_line.Position            = vec3 (0, 0.04, EPS / 2)
  stroked_line.FontCreationParams  = game.font_creation_params
  stroked_line.Material            = "text_material"
  stroked_line.Scissor             = scissor
  
  stroked_line:BindToParent (line, Scene.NodeBindMode.AddRef)
end

local function ShowWinTable (impl, state)
  if impl.battle_active then return end
  if not impl.win_close_button then return end

  local lines_count = 0
  
  for i = 1, #impl.win_lines do
    local line = impl.win_lines [i]
    
    if line.type == 1 then
      lines_count = lines_count + 1
    end
  end
  
  if state and lines_count > 0 then
    impl.win_table_node = Scene.Node.Create ()
  
    ActivateSprite (impl.win_close_button)
    impl.win_table_node_position = impl.win_close_button.node.Position
    DeactivateSprite (impl.win_close_button)

    impl.win_table_node_position.z = impl.win_table_z

    impl.win_table_node.Position = impl.win_table_node_position
    impl.win_table_node:BindToParent (game.current_screen.node)

    local header                   = Scene.Sprite.Create ()
    local header_height            = impl.win_table_header.layout:Get ("Height") + 0
    local line_height              = impl.win_line.layout:Get ("Height") + 0
    local line_offset              = line_height + impl.win_line_sprite_offset_y
    local line_width               = impl.win_line.layout:Get ("Width") + 0
    local line_material            = impl.win_line.node.Material
    local line_tex_size            = StringToVec (impl.win_line.layout:Get ("TexSize"))
    local line_tex_offset          = StringToVec (impl.win_line.layout:Get ("TexOffset"))
    local selected_line_height     = impl.win_line_selected.layout:Get ("Height") + 0
    local selected_line_width      = impl.win_line_selected.layout:Get ("Width") + 0
    local selected_line_material   = impl.win_line_selected.node.Material
    local selected_line_tex_size   = StringToVec (impl.win_line_selected.layout:Get ("TexSize"))
    local selected_line_tex_offset = StringToVec (impl.win_line_selected.layout:Get ("TexOffset"))
    
    header.Material  = impl.win_table_header.node.Material
    header.Scale     = vec3 (impl.win_table_header.layout:Get ("Width") + 0, header_height, 1)
    header.Position  = vec3 (impl.win_line_header_offset_x, impl.win_line_header_offset_y, -EPS)
    header.TexSize   = StringToVec (impl.win_table_header.layout:Get ("TexSize"))
    header.TexOffset = StringToVec (impl.win_table_header.layout:Get ("TexOffset"))
    header.Scissor   = impl.win_table_scissor
    
    header:BindToParent (impl.win_table_node, Scene.NodeBindMode.AddRef)
    
    CreateWinTableTextLine (header, impl.win_lines_text_offset_x, impl.win_lines_title_text_offset_y, GetLocalizedString ("WIN_TABLE.LINES"), impl.win_lines_title_color, impl.win_lines_title_size, impl.win_lines_title_stroke_color, impl.win_table_scissor)
    CreateWinTableTextLine (header, impl.win_win_text_offset_x, impl.win_win_title_text_offset_y, GetLocalizedString ("WIN_TABLE.WIN"), impl.win_win_title_color, impl.win_win_title_size, impl.win_win_title_stroke_color, impl.win_table_scissor)

    local z = 0
  
    for i = 1, #impl.win_lines do
      local line = impl.win_lines [i]
    
      if line.type == 1 then
        local node = Scene.Node.Create ()
        
        node.Position = vec3 (0, -header_height / 2 - line_offset * (i - 0.5), z)

        z = z + EPS

        node:BindToParent (impl.win_table_node, Scene.NodeBindMode.AddRef)
        
        local line_node = Scene.Sprite.Create ()
    
        line_node.Material  = line_material
        line_node.Scale     = vec3 (line_width, line_height, 1)
        line_node.TexSize   = line_tex_size
        line_node.TexOffset = line_tex_offset
        line_node.Scissor   = impl.win_table_scissor
    
        line_node:BindToParent (node, Scene.NodeBindMode.AddRef)

        local selected_line_node = Scene.Sprite.Create ()
    
        selected_line_node.Material  = selected_line_material
        selected_line_node.Scale     = vec3 (selected_line_width, selected_line_height, 1)
        selected_line_node.TexSize   = selected_line_tex_size
        selected_line_node.TexOffset = selected_line_tex_offset
        selected_line_node.Scissor   = impl.win_table_scissor
    
        local function CreateLineButton (node)
          AttachInputZoneToNode (node, Scene.InputZoneNotification.OnClick, function ()
            if impl.free_spins_label_shown or impl.bonus_occured then return end
        
            PlaySound (impl.win_table_line_click_sound)
            
            local_methods.AnimateWinLine (impl, i)
          end)
        end
    
        CreateLineButton (line_node)
        CreateLineButton (selected_line_node)
    
        CreateWinTableTextLine (node, impl.win_lines_text_offset_x, impl.win_lines_value_text_offset_y, tostring (line.line), impl.win_lines_value_color, impl.win_lines_value_size, impl.win_lines_value_stroke_color, impl.win_table_scissor)
        CreateWinTableTextLine (node, impl.win_win_text_offset_x, impl.win_win_value_text_offset_y, FormatMoneyString (line.payout, WINTABLE_LINE_DIGITS_COUNT), impl.win_win_value_color, impl.win_win_value_size, impl.win_win_value_stroke_color, impl.win_table_scissor)
        
        line.win_table_node          = node
        line.win_table_line          = line_node
        line.win_table_selected_line = selected_line_node
      end
    end
    
    impl.win_table_height = header_height + impl.win_line_header_offset_y + line_offset * lines_count

    if impl.win_table_footer then
      local footer        = Scene.Sprite.Create ()
      local footer_height = impl.win_table_footer.layout:Get ("Height") + 0
    
      footer.Material  = impl.win_table_footer.node.Material
      footer.Scale     = vec3 (impl.win_table_footer.layout:Get ("Width") + 0, footer_height, 1)
      footer.Position  = vec3 (0, -impl.win_table_height + footer_height * 0.5 + impl.win_line_footer_offset_y, z)
      footer.TexSize   = StringToVec (impl.win_table_footer.layout:Get ("TexSize"))
      footer.TexOffset = StringToVec (impl.win_table_footer.layout:Get ("TexOffset"))
      footer.Scissor   = impl.win_table_scissor
    
      footer:BindToParent (impl.win_table_node, Scene.NodeBindMode.AddRef)
    
      impl.win_table_height = impl.win_table_height + footer_height + impl.win_line_footer_offset_y
    end
    
    impl.win_table_height = impl.win_table_height + impl.win_table_offset_y
  
    OpenWinTable (impl, true)
  else
    SetSpritesActive (false, impl.win_close_button, impl.win_open_button)

    game.scripts.buttons.SetButtonActive (impl.win_close_button.name, false, true)
    game.scripts.buttons.SetButtonActive (impl.win_open_button.name, false, true)

    if impl.win_table_node then
      impl.win_table_node:Unbind ()
      impl.win_table_node = nil
    end
  end
end

local function UpdateBetText (impl)
  local bet = 0
  
  if impl.bet then
    bet = impl.bet.money
  end
  
  if impl.double_bet_active then
    bet = bet * 2
  end
  
  impl.bet_text_line.node.Text       = FormatMoneyString (bet)
  impl.total_bet_text_line.node.Text = FormatMoneyString (bet * impl.active_lines, impl.total_bet_max_symbols_count) 
--  impl.total_bet_text_line.node.Text = FormatMoneyString (8888800, impl.total_bet_max_symbols_count) --DEBUG

  impl.previous_bet = impl.previous_bet or 0

  if impl.previous_bet ~= bet and impl.event_handler and impl.event_handler.OnBetChanged then
    impl.event_handler.OnBetChanged ()
  end
  
  impl.previous_bet = bet
end

local function UpdateLinesButtonsState (impl)
  for i = 1, impl.active_lines do
    local line = impl.lines [i]
  
    SetSpritesActive (false, line.left_disabled, line.right_disabled)
    SetSpritesActive (true, line.left_enabled, line.right_enabled)
    
    if impl.event_handler and impl.event_handler.OnLineActivate then
      if line.active ~= true then
        line.active = true
        impl.event_handler.OnLineActivate (i, true)
      end
    end
  end                 
  for i = impl.active_lines + 1, #impl.lines do
    local line = impl.lines [i]
  
    SetSpritesActive (true, line.left_disabled, line.right_disabled)
    SetSpritesActive (false, line.left_enabled, line.right_enabled)
    
    if impl.event_handler and impl.event_handler.OnLineActivate then
      if line.active ~= false then
        line.active = false
        
        impl.event_handler.OnLineActivate (i, false)
      end
    end
  end                 
  
  impl.lines_text_line.node.Text = tostring (impl.active_lines)
  
  UpdateBetText (impl)
end

local function HideLines (impl)
  for i = 1, #impl.lines do
    local line = impl.lines [i]
    
    for j = 1, #line.line_sprites do
      line.line_sprites [j]:Unbind ()
      line.line_sprites [j].Alpha = 1
    end
  end

  for i = 1, #impl.win_lines do
    local line = impl.win_lines [i]
    
    for j = 1, #line.line_sprites do
      line.line_sprites [j]:Unbind ()
    end
  end
end

local function StopWinAnimation (impl)
  if impl.current_symbol_sound then
    StopStoredSound (impl.current_symbol_sound)
  end

  if impl.animate_win_action then
    impl.animate_win_action.Stop ()
  end
  
  impl.animate_win_action = nil
  
  if impl.win_animations_node.Parent then
    UpdateLinesButtonsState (impl)
  end

  if impl.win_animations then
    for i = 1, #impl.win_animations do
      impl.win_animations [i].animation.Hide ()
      impl.win_animations [i].symbol.sprite.Alpha = 1
    end
  end
  
  impl.win_animations = nil

  HideLines (impl)
end

local function ClearWinLines (impl) 
  StopWinAnimation (impl)
  ShowWinTable (impl, false)
end

local function ActivateLines (impl, count, show, sound_name)
  if impl.spin_started then return end
  if show and impl.battle_active then return end
  
  if sound_name then
    PlaySound (sound_name)
  end

  StopWinAnimation (impl)

  impl.active_lines = count

  UpdateLinesButtonsState (impl)

  if show then
    HideLines (impl)
  
    for i = 1, count do
      local line = impl.lines [i]
    
      for j = 1, #line.line_sprites do
        line.line_sprites [j]:BindToParent (impl.win_animations_node)
      end
    end
  end

  if impl.event_handler and impl.event_handler.OnLinesChanged then
    impl.event_handler.OnLinesChanged ()
  end
end

local function SetUiState (impl, state)
  impl.ui_state = state

  if not impl.play_button_hidden then
    SetSpritesActive (not state, impl.play_button_disabled)
    SetSpritesActive (state, impl.play_button_enabled)
  
    if not impl.phone_ui then
      SetTextLineActive (impl.play_active_text, state)
      SetTextLineActive (impl.play_passive_text, not state)
    end
  end

  if not impl.battle_active then
    SetSpritesActive (not state, impl.bet_less_button_disabled, impl.bet_more_button_disabled, 
                      impl.lines_less_button_disabled, impl.lines_more_button_disabled,
                      impl.payment_table_button_disabled, impl.all_lines_button_disabled)
    SetSpritesActive (state, impl.bet_less_button_enabled, impl.bet_more_button_enabled, 
                      impl.lines_less_button_enabled, impl.lines_more_button_enabled,
                      impl.payment_table_button_enabled, impl.all_lines_button_enabled)

    SetTextLinesActive (state, unpack (impl.payment_table_line_active))
    SetTextLinesActive (not state, unpack (impl.payment_table_line_passive))

    if not impl.phone_ui then
      SetTextLinesActive (state, unpack (impl.all_lines_active_text))
      SetTextLinesActive (not state, unpack (impl.all_lines_passive_text))
    end
  end

  if game.scripts.boosters_overlay then
    game.scripts.boosters_overlay.SetState (state)
  end
end

local function GetSymbolCenter (impl, symbol_index)
  local reel = impl.reels [symbol_index % #impl.reels + 1]
  local line = math.floor (symbol_index / #impl.reels)

  return vec3 (reel.start_position.x, reel.start_position.y - line * impl.line_interval, 0)
end

local function CreateLineSprite (material, color, width, from, to, lines_z)
  local direction   = to - from
  local line_sprite = Scene.Sprite.Create ()
            
  line_sprite.Material      = material
  line_sprite.Color         = color
  line_sprite.Scale         = vec3 (direction.length, width, 1)
  line_sprite.PivotPosition = vec3 (-0.5, 0, 0)
  line_sprite.Position      = from + vec3 (0, 0, lines_z)
            
  line_sprite:LookTo (vec3 (to.x, to.y, 0), Scene.NodeOrt.X, Scene.NodeOrt.Z, Scene.NodeTransformSpace.World)
  
  return line_sprite
end

local function FindSegmentsIntersection (start1, end1, start2, end2)
  local x1 = start1.x
  local x2 = end1.x
  local x3 = start2.x
  local x4 = end2.x
  local y1 = start1.y
  local y2 = end1.y
  local y3 = start2.y
  local y4 = end2.y
  
  local ua = ((x4 - x3) * (y1 - y3) - (y4 - y3) * (x1 - x3)) / ((y4 - y3) * (x2 - x1) - (x4 - x3) * (y2 - y1))
  local ub = ((x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)) / ((y4 - y3) * (x2 - x1) - (x4 - x3) * (y2 - y1))
  
  if ua > -EPS and ua < 1 + EPS and ub > -EPS and ub < 1 + EPS then
    return { x = start1.x + ua * (end1.x - start1.x), y = start2.y + ub * (end2.y - start2.y) }
  else
    return nil
  end
end

local function FindSquareIntersection (line_start, line_end, square)
  local top_intersection    = FindSegmentsIntersection (line_start, line_end, square.top_left,    square.top_right)
  local bottom_intersection = FindSegmentsIntersection (line_start, line_end, square.bottom_left, square.bottom_right)
  local left_intersection   = FindSegmentsIntersection (line_start, line_end, square.top_left,    square.bottom_left)
  local right_intersection  = FindSegmentsIntersection (line_start, line_end, square.top_right,   square.bottom_right)
  
  local nearest_intersection          = nil
  local nearest_intersection_distance = 99999999
  
  local function FindNearestIntersection (intersection)
    if not intersection then return end
    
    local distance = vec2 (intersection.x - line_start.x, intersection.y - line_start.y).length
    
    if distance < nearest_intersection_distance then
      nearest_intersection          = intersection
      nearest_intersection_distance = distance
    end
  end
  
  FindNearestIntersection (top_intersection)  
  FindNearestIntersection (bottom_intersection)  
  FindNearestIntersection (left_intersection)  
  FindNearestIntersection (right_intersection)  
  
  return nearest_intersection, nearest_intersection_distance
end

local function IsPointInsideSquare (point, square)
  local eps = EPS * 10

  return point.x > square.top_left.x - eps and point.x < square.top_right.x + eps and 
         point.y > square.bottom_left.y - eps and point.y < square.top_left.y + eps
end

local function GetWinSymbol (impl, symbol_index)
  local reel = impl.reels [symbol_index % #impl.reels + 1]
  local line = math.floor (symbol_index / #impl.reels)

  return reel.items [line + reel.stop_position]
end

local_methods.GetBonusSpinSymbolSprite = function (impl)
  local symbols_count = #impl.reels * 3
 
  for i = 1, symbols_count do
    local item = GetWinSymbol (impl, i - 1)

    if item.desc.bonus_spin then 
      return item.sprite
    end
  end
  
  return nil
end

local function ParseWins (impl, event)
  impl.bonus_occured = event:Find ("bonus"):Attribute (0) == "true"
  impl.free_spins    = event:Find ("freeSpins"):Attribute (0) + 0 
  impl.total_payout  = event:Find ("totalPayout"):Attribute (0) + 0
  
  local five_in_row_node = event:Find ("fiveInRowSymbolId")
  
  if five_in_row_node then
    impl.five_in_row_symbol = five_in_row_node:Attribute (0) + 1
    impl.five_in_row_payout = event:Find ("fiveInRowSymbolPayout"):Attribute (0) + 0
  else
    impl.five_in_row_symbol = nil
  end

  if impl.free_spins > 0 then
    System.Application.ScreenSaverState = false
  end

  local wins_node   = event:Find ("wins"):Child (0)
  local lines_count = wins_node.ChildrenCount
  
  impl.win_lines = {}

  impl.new_free_spins_added    = false
  impl.needs_choose_free_spins = false

  for i = 0, lines_count - 1 do
    local line_node = wins_node:Child (i)
    local win_desc  = {}
    
    win_desc.type   = line_node:Find ("type"):Attribute (0) + 0
    win_desc.line   = line_node:Find ("line"):Attribute (0) + 0
    win_desc.payout = line_node:Find ("payout"):Attribute (0) + 0

    win_desc.symbols = {}
    
    local symbols_node  = line_node:Find ("symbols"):Child (0)
    local symbols_count = symbols_node.AttributesCount

    for j = 0, symbols_count - 1 do
      table.insert (win_desc.symbols, symbols_node:Attribute (j) + 0)
    end

    if win_desc.type == 3 then
      if win_desc.payout == 0 then
        impl.needs_choose_free_spins = {}
        impl.needs_choose_free_spins.symbols = {}
        
        for j = 1, #win_desc.symbols do
          local symbol = {}
          
          symbol.index = win_desc.symbols [j]

          local win_symbol = GetWinSymbol (impl, symbol.index)

          symbol.node = win_symbol.sprite 
          
          table.insert (impl.needs_choose_free_spins.symbols, symbol)
        end
      else
        impl.new_free_spins_added = true
      end
    end

    win_desc.line_sprites = {}
    
    local material
    local width      = game.current_screen.vars.line_width
    local half_width = width / 2
    local color
    local points
    local prev_point
    local lines_z    = impl.lines_z
    
    if win_desc.line > 0 then
      local line = impl.lines [win_desc.line]
    
      material = line.material
      color    = line.color
      points   = line.points             
    else
      material = impl.scatter_line_material
      color    = impl.scatter_line_color
      points   = {}
    end

    if win_desc.type == 2 then  --do not show line if bonus occured
      win_desc.line = 0
       
      points = {}
    end

    local square_half_width = impl.line_interval / 2 * game.current_screen.vars.slot_line_square_size

    local squares = {}

    for j = 1, #win_desc.symbols do
      local reel_index = win_desc.symbols [j] % #impl.reels + 1

      local top_left_corner
      local top_right_corner
      local bottom_left_corner
      local bottom_right_corner

      if impl.wide_reels [reel_index] then
        local top_cell_center    = GetSymbolCenter (impl, reel_index - 1)
        local bottom_cell_center = GetSymbolCenter (impl, reel_index - 1 + 2 * #impl.reels)

        top_left_corner     = top_cell_center + vec3 (-square_half_width, square_half_width, 0)
        top_right_corner    = top_cell_center + vec3 (square_half_width, square_half_width, 0)
        bottom_left_corner  = bottom_cell_center + vec3 (-square_half_width, -square_half_width, 0)
        bottom_right_corner = bottom_cell_center + vec3 (square_half_width, -square_half_width, 0)
      else
        local cell_center = GetSymbolCenter (impl, win_desc.symbols [j])

        top_left_corner     = cell_center + vec3 (-square_half_width, square_half_width, 0)
        top_right_corner    = cell_center + vec3 (square_half_width, square_half_width, 0)
        bottom_left_corner  = cell_center + vec3 (-square_half_width, -square_half_width, 0)
        bottom_right_corner = cell_center + vec3 (square_half_width, -square_half_width, 0)
      end
    
      table.insert (squares, { top_left = top_left_corner, top_right = top_right_corner, bottom_left = bottom_left_corner, bottom_right = bottom_right_corner })

      local top_line    = CreateLineSprite (material, color, width, top_left_corner + vec3 (-half_width, 0, 0), top_right_corner + vec3 (half_width, 0, 0), lines_z)
      local bottom_line = CreateLineSprite (material, color, width, bottom_left_corner + vec3 (-half_width, 0, 0), bottom_right_corner + vec3 (half_width, 0, 0), lines_z)
      local left_line   = CreateLineSprite (material, color, width, top_left_corner, bottom_left_corner, lines_z)
      local right_line  = CreateLineSprite (material, color, width, top_right_corner, bottom_right_corner, lines_z)

      lines_z = lines_z - EPS
            
      table.insert (win_desc.line_sprites, top_line)
      table.insert (win_desc.line_sprites, bottom_line)
      table.insert (win_desc.line_sprites, left_line)
      table.insert (win_desc.line_sprites, right_line)
    end

    for j = 1, #points do
      local current_point = points [j]
        
      if prev_point then
        local segment_direction = current_point - prev_point

        segment_direction = segment_direction:normalize ()
            
        local squared_line_processed = false

        while not squared_line_processed do
          local nearest_intersection_distance = 9999999
          local nearest_intersection_square
          local nearest_intersection
          local line_in_square
            
          for k = 1, #squares do
            local square = squares [k] 

            line_in_square = IsPointInsideSquare (prev_point, square) and IsPointInsideSquare (current_point, square)

            if line_in_square then break end

            local intersection, distance = FindSquareIntersection (prev_point, current_point, square)
                
            if distance < nearest_intersection_distance then
              nearest_intersection          = intersection
              nearest_intersection_distance = distance
              nearest_intersection_square   = square
            end
          end
              
          if nearest_intersection then
            nearest_intersection = vec3 (nearest_intersection.x, nearest_intersection.y, 0)
          
            if IsPointInsideSquare (prev_point, nearest_intersection_square) then  --prev_point inside square
              prev_point = nearest_intersection + segment_direction
               
              if IsPointInsideSquare (current_point, nearest_intersection_square) then
                squared_line_processed = true
              end
            else                                                                   --prev_point inside square
              local line_sprite = CreateLineSprite (material, color, width, prev_point, nearest_intersection, lines_z)

              table.insert (win_desc.line_sprites, line_sprite)
               
              if IsPointInsideSquare (current_point, nearest_intersection_square) then
                squared_line_processed = true
              else
                prev_point = nearest_intersection + segment_direction
              end
            end
          else
            if not line_in_square then
              local line_sprite = CreateLineSprite (material, color, width, prev_point, current_point, lines_z)

              table.insert (win_desc.line_sprites, line_sprite)
            end

            squared_line_processed = true
          end
        end

        lines_z = lines_z - EPS
      end
      
      prev_point = current_point
    end

    if not impl.ignore_bonus_win or win_desc.type ~= 2 then
      table.insert (impl.win_lines, win_desc)
    end
  end
end

local function ParseReelsPositions (impl, event)
  local reels_node  = event:Find ("reels"):Child (0)
  local reels_count = reels_node.AttributesCount
  
  local stop_positions = {}
  
  for i = 0, reels_count - 1 do
    local position = reels_node:Attribute (i) + 1
  
    impl.reels [i + 1].stop_position = position
    
    table.insert (stop_positions, position)
  end
  
  impl.wide_reels = { false, false, false, false, false }

  local stop_sounds = { nil, nil, nil, nil, nil }

  for i = 1, reels_count do
    for j = 1, 3 do                                             --lines count
      local symbol = GetWinSymbol (impl, i - 1 + (j - 1) * reels_count)
      
      if symbol.desc.wide then
        impl.wide_reels [i] = true
      end
      
      if symbol.desc.stop_sound then
        stop_sounds [i] = symbol.desc.stop_sound
      end
      
      if symbol.desc.wild then        --TODO move to stop_sound
        stop_sounds [i] = impl.wild_stop_sound
      end
      
      if symbol.desc.double_wild and impl.double_wild_stop_sound then --TODO move to stop_sound
        stop_sounds [i] = impl.double_wild_stop_sound
      end
    end
  end
  
  impl.spin_engine.StopSpin (stop_positions, stop_sounds)
end

local function OnBetUpdated (impl, event)
  local bet_id = event:Find ("betId"):Attribute (0) + 0 

  local bets = GetBets ()
  
  for i = 1, #bets do
    local bet = bets [i]
    
    if bet.id == bet_id then
      impl.bet = bet
      break
    end
  end

  UpdateBetText (impl)
end

local function OnSlotSpinResponse (impl, event)
  ParseReelsPositions (impl, event)
  ParseWins (impl, event)
  
  impl.last_slot_spin_response = event

  impl.needs_stop_spinning = true
end

local function OnFreeSpinsGain (impl, event)
  ApplicationDataSet (FREE_SPINS_GAIN, event)

  if impl.slot_id ~= event:Find ("slotId"):Attribute (0) + 0 then
    print ("received free spins gain event for other slot!!!!!")
    return 
  end 
  
  impl.total_free_spins_count  = event:Find ("count"):Attribute (0) + 0
  impl.total_free_spins_payout = event:Find ("payout"):Attribute (0) + 0
  
  impl.free_spins_win_count_text_line.node.Text  = tostring (impl.total_free_spins_count)
  impl.free_spins_win_payout_text_line.node.Text = FormatMoneyString (impl.total_free_spins_payout, impl.free_spins_payout_max_digits_count, nil, true)
end

local function UpdateBalanceText (impl, value)
  if not value then
    value = GetUserMoney ()
  end 

  game.scripts.top_ui.MoneyForceUpdate (value)  
  game.scripts.top_ui.DiamondsForceUpdate (GetUserDiamonds ())  

  if not impl.phone_ui then
    SetNumberInStringSlowly (impl.balance_text_line, impl.balance, value, nil, function (val)
      return FormatMoneyString (val, impl.max_balance_symbols, value % 100 ~= 0)
    end)
  end
  
  impl.balance = value
end

local_methods.GetCurrentBetIndex = function (impl)
  local bets = GetBets ()
  
  for i = 1, #bets do
    local bet = bets [i]
    
    if bet.id == impl.bet.id then
      return i
    end
  end
  
  error ("Can't find current bet index for id " .. tostring (impl.bet.id))
end

local function DimSymbols (impl, dim_symbols, undim)
  local color

  if undim then
    color = vec4 (1)

    impl.dimmed_symbols = nil
  else
    color = vec4 (0.5, 0.5, 0.5, 1)

    impl.dimmed_symbols = dim_symbols
  end

  for i = 1, #dim_symbols do
    local symbol = GetWinSymbol (impl, dim_symbols [i])
    
    symbol.sprite.Color = color
  end
end

local function ActivateDoubleBet (impl) 
  impl.double_bet_active = true
  
  UpdateBetText (impl)
end

local_methods.ShowMegaLines = function (impl)
  for i = 1, #impl.lines do
    local line = impl.lines [i]

    SetSpritesActive (false, line.left_disabled, line.right_disabled, line.left_enabled, line.right_enabled)
  end             
  
  ActivateSprites (unpack (impl.mega_lines_show_sprites))
  ActivateTextLines (unpack (impl.mega_lines_show_text_lines))
  DeactivateSprites (unpack (impl.mega_lines_hide_sprites))
  DeactivateTextLines (unpack (impl.mega_lines_hide_text_lines))
end

local function Play (impl, hold_reels, no_spin_start_sound, params)
  if impl.spin_started then return end

  if impl.autospin_paused then
    local_methods.ResetAutoSpins (impl)
  end

  impl.current_has_more_autospins = impl.has_more_autospins

  params = params or {}

  local next_spin_params = impl.next_spin_params or {}
  
  impl.next_spin_params = nil

  ForEachIndexInTable (next_spin_params, function (index)
    params [index] = next_spin_params [index]
  end)
  
  impl.turbo_force_activated = impl.turbo_force_activated or params.turbo_force_activated

  if not impl.spin_tutorial_completed then
    impl.spin_tutorial_completed = true
    HsConnectionSendMessage (1, { event = "tutorial.complete", step = 2 })
  end

  local turbo_booster_spins = 0

  local boosters = GetPowerups ()
  
  for i = 1, #boosters do
    local booster = boosters [i]
    
    if booster.id == 1 then
      turbo_booster_spins = booster.spins_left
      break
    end
  end

  if impl.spin_start_sound and not no_spin_start_sound then
    local spin_start_sound = impl.spin_start_sound
  
    if turbo_booster_spins > 0 then
      spin_start_sound = "battle_turbo_spin_click"
    end
  
    PlaySound (spin_start_sound)
  end

  if impl.dimmed_symbols then
    DimSymbols (impl, impl.dimmed_symbols, true)
  end
  
  impl.game_started                  = true
  impl.last_win_value                = 0
  impl.bonus_icons_count             = 0
  impl.needs_play_bonus_yes_no_sound = nil
  impl.stopped_bonus_icons_count     = 0
  impl.highlighted_symbols           = {}
  
  if impl.current_symbol_sound then
    StopStoredSound (impl.current_symbol_sound)
  end

  impl.ignore_bonus_win = false

  local bets = GetBets ()

  local total_bet_value = impl.bet.money * impl.active_lines

  if impl.double_bet_active then
    total_bet_value = total_bet_value * 2
  end

  if (not params.bonus_spin and impl.free_spins == 0 and GetUserMoney () < bets [1].money) or (impl.balance < total_bet_value and impl.battle_active) then
    game.scripts.ui_windows.ShowNoMoneyWindow ()
    return
  end 

  if not params.bonus_spin and impl.free_spins == 0 and impl.balance < impl.bet.money * impl.active_lines then
    game.scripts.ui_windows.ShowNotEnoughMoneyWindow (function ()
      local current_bet_index = local_methods.GetCurrentBetIndex (impl)
      local bet_found         = false
  
      for i = current_bet_index, 1, -1 do
        local bet = bets [i]
      
        if bet.money * impl.active_lines <= impl.balance then
          impl.bet = bet
          bet_found = true
          break
        end
      end

      if not bet_found then
        impl.bet          = bets [1]
        impl.active_lines = math.floor (impl.balance / impl.bet.money)
        
        ActivateLines (impl, impl.active_lines, false)
      end

      UpdateBetText (impl)
      
      Play (impl, nil, true)
    end)
    return
  end

  OpenWinTable (impl, false, function ()
    DelayedAction ("default", 0.2, function ()
      ShowWinTable (impl, false)
    end)
  end)

  DelayedAction ("default", 0.25, function ()
    impl.win_text_line.node.Text = FormatMoneyString (0)
  end)
  
  HideLines (impl)
  StopWinAnimation (impl)

  impl.total_free_spins_count  = nil
  impl.total_free_spins_payout = nil

  SetUiState (impl, false)

  impl.spin_started = true
  
  impl.win_lines = {}

  local bet = 0
  
  if impl.bet then
    bet = impl.bet.money
  end
  
  if impl.double_bet_active then
    bet = bet * 2
  end

  local spin_sound_name

  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end
  
  local dont_update_balance = params.dont_update_balance

  local spin_bet
  
  if params.mega_lines then
    spin_bet = bet * 99
  else
    spin_bet = bet * impl.active_lines
  end
  
  if impl.free_spins > 0 and free_spins_allowed then
    impl.free_spins_started = true
  
    impl.current_free_spins_spinning_sound = impl.current_free_spins_spinning_sound % #impl.free_spins_spinning_sounds + 1
    
    spin_sound_name = impl.free_spins_spinning_sounds [impl.current_free_spins_spinning_sound]
  elseif turbo_booster_spins > 0 or impl.turbo_force_activated then
    if not dont_update_balance then
      UpdateBalanceText (impl, impl.balance - spin_bet)
    end
    
    spin_sound_name = "battle_turbo_spin"
  else
    if not dont_update_balance then
      UpdateBalanceText (impl, impl.balance - spin_bet)
    end
    
    impl.current_spinning_sound = impl.current_spinning_sound % #impl.spinning_sounds + 1
    
    spin_sound_name = impl.spinning_sounds [impl.current_spinning_sound]
  end

  impl.spin_start_time = game.current_screen.timers.default:GetTime ()

  local spinning_directions

  if impl.free_spins_spinning_directions then
    if impl.free_spins > 0 and free_spins_allowed then
      spinning_directions = impl.free_spins_spinning_directions
    else
      spinning_directions = { true, true, true, true, true }
    end
  end

  if hold_reels then
    for i = 1, #hold_reels do
      spinning_directions [hold_reels [i]] = nil 
    end
  end

  impl.spin_engine.SetSpinningDirections (spinning_directions)

  if params.no_spin_sound then
    spin_sound_name = nil
  end

  impl.spin_engine.StartSpin (spin_sound_name, (impl.free_spins > 0 and free_spins_allowed) or turbo_booster_spins > 0 or impl.turbo_force_activated)

  impl.turbo_force_activated = false

  if game.scripts.boosters_overlay then
    game.scripts.boosters_overlay.OnSpinStarted (turbo_booster_spins)
  end

  game.scripts.top_ui.OnSpinStarted ()
  
  if impl.event_handler and impl.event_handler.OnSpinStarted then
    impl.event_handler.OnSpinStarted ()
  end

  game.scripts.top_ui.SetDiamondsAutoUpdate (false)

  local hold_reels_for_event
  
  if hold_reels then
    hold_reels_for_event = {}
  
    for i = 1, #hold_reels do
      table.insert (hold_reels_for_event, hold_reels [i] - 1)
    end
  end

  if params.mega_lines or impl.active_lines == 99 then
    impl.active_lines = 99
  
    UpdateLinesButtonsState (impl)

    if impl.event_handler and impl.event_handler.OnLinesChanged then
      impl.event_handler.OnLinesChanged ()
    end

    local_methods.ShowMegaLines (impl)

    impl.mega_spins_activated = true
  end

  HsConnectionSendMessage (1, { event = "slot.spin", slotId = impl.slot_id, betId = impl.bet.id, lines = impl.active_lines, hold = hold_reels_for_event })
end

local_methods.SetAutoSpinPaused = function (impl, state, no_spin)
  impl.autospin_paused = state 

  if state then
    if impl.spin_started then return end
    
    if impl.game_started and impl.total_payout > 0 and not impl.bonus_occured and impl.free_spins == 0 and not ApplicationDataGet (FREE_SPINS_GAIN) and   
      impl.event_handler and impl.event_handler.OnDoubleAvailable and not impl.needs_choose_free_spins then
      impl.event_handler.OnDoubleAvailable ()
    end
  
    if impl.free_spins == 0 and not impl.bonus_occured and not impl.needs_choose_free_spins and not impl.total_free_spins_count then
      if impl.lines_animation_ended_play_action then
        impl.lines_animation_ended_play_action.Stop ()
        impl.lines_animation_ended_play_action = nil
      end
     
      SetUiState (impl, true)
    end
  elseif not no_spin and not impl.spin_started then 
    Play (impl, nil, true)
  end
end

local function AllLinesPlay (impl)
  ActivateLines (impl, impl.lines_count, false)
  Play (impl)
end

local_methods.GetMaxBetIndex = function (impl)
  local user_level = GetUserLevel ()
  local bets       = GetBets ()
  
  for i = 1, #bets do
    local bet = bets [i]
    
    if bet.id == user_level.max_bet_id then
      return i
    end
  end
  
  error ("Can't find max bet index for id " .. tostring (user_level.max_bet_id))
end

local function BetLess (impl)
  if impl.next_bet_less_disabled then
    impl.next_bet_less_disabled = nil
    return
  end

  local current_bet_index = local_methods.GetCurrentBetIndex (impl)
  local max_bet_index     = local_methods.GetMaxBetIndex (impl)
  local bets              = GetBets ()
  
  local bet_index = current_bet_index - 1
  
  if bet_index < 1 then
    bet_index = max_bet_index
  end
  
  impl.bet = bets [bet_index]

  UpdateBetText (impl)
end

local function BetMore (impl)
  if impl.next_bet_more_disabled then
    impl.next_bet_more_disabled = nil
    return
  end

  local current_bet_index = local_methods.GetCurrentBetIndex (impl)
  local max_bet_index     = local_methods.GetMaxBetIndex (impl)
  local bets              = GetBets ()
  
  local bet_index = current_bet_index + 1
  
  if bet_index > max_bet_index then
    bet_index = 1
  end
  
  impl.bet = bets [bet_index]

  UpdateBetText (impl)
end

local function LinesLess (impl)
  if impl.next_lines_less_disabled then
    impl.next_lines_less_disabled = nil
    return
  end

  impl.active_lines = impl.active_lines - 1
  
  if impl.active_lines == 0 then
    impl.active_lines = impl.lines_count
  end
  
  ActivateLines (impl, impl.active_lines, true)
end

local function LinesMore (impl)
  if impl.next_lines_more_disabled then
    impl.next_lines_more_disabled = nil
    return
  end

  impl.active_lines = impl.active_lines + 1
  
  if impl.active_lines > impl.lines_count then
    impl.active_lines = 1
  end
  
  ActivateLines (impl, impl.active_lines, true)
end

local function ShowPaymentTablePage (impl, state)
  local page = impl.paytable_pages [impl.active_paytable_page]

  for i = 1, #page.sprites do
    SetSpriteActive (page.sprites [i], state)
  end
 
  for i = 1, #page.text_lines do
    SetTextLineActive (page.text_lines [i], state)
  end
  
  if impl.phone_ui and game.scripts.bottom_ui then
    game.scripts.bottom_ui.AnimatedShow (not state, BOTTOM_PANEL_HIDE_DURATION)
  end
  
  if impl.event_handler and impl.event_handler.OnPaymentTablePageActivated then
    impl.event_handler.OnPaymentTablePageActivated (impl.active_paytable_page)
  end
end

local function PaymentTableForward (impl)
  ShowPaymentTablePage (impl, false)
  impl.active_paytable_page = impl.active_paytable_page + 1
  ShowPaymentTablePage (impl, true)
end

local function PaymentTableBack (impl)
  ShowPaymentTablePage (impl, false)
  impl.active_paytable_page = impl.active_paytable_page - 1
  ShowPaymentTablePage (impl, true)
end

local function UpdateLineAnimation (impl, line_index, phase, full)
  local win_line = impl.win_lines [line_index]
  local line     = impl.lines [win_line.line]

  local alpha = 1
  
  if phase > 0.9 then
    alpha = (1 - phase) / 0.1
  end
  if phase < 0.1 then
    alpha = phase / 0.1
  end

  if line then
    if impl.win_animations_node.Parent then
      SetSpritesActive (phase > 0.8, line.left_disabled, line.right_disabled)
      SetSpritesActive (phase <= 0.8, line.left_enabled, line.right_enabled)
    end
    
    if not full then
      for i = 1, #line.line_sprites do
        line.line_sprites [i].Alpha = alpha
      end
    end
  end

  if full then
    for i = 1, #win_line.line_sprites do
      win_line.line_sprites [i].Alpha = alpha
    end
  end
end

local function ShowFreeSpinsLabel (impl, state)
  if impl.free_spins_label_shown == state then return end

  impl.current_free_spins_spinning_sound = 0

  if impl.free_spins_count_text_line then
    SetTextLineActive (impl.free_spins_count_text_line, state)
  end
  
  if impl.phone_ui then
    SetSpriteActive ("free_games_background", state)
    SetTextLineActive ("free_spins_legend", state)
  else
    game.scripts.buttons.SetButtonActive (impl.win_close_button.name, not state, true)
    game.scripts.buttons.SetButtonActive (impl.win_open_button.name, not state, true)
  end

  if impl.event_handler and impl.event_handler.OnShowFreeSpinsLabel then
    impl.event_handler.OnShowFreeSpinsLabel (impl.phone_ui, state)
  end
  
  impl.free_spins_label_shown = state
end

local function ShowFreeSpinsWin (impl, state)
  SetSpritesActive (state, unpack (impl.free_spins_results_sprites))
  SetSpritesActive (state, unpack (impl.free_spins_win_sprites))
  
  SetTextLinesActive (state, unpack (impl.free_spins_win_text_lines))
  SetTextLinesActive (state, impl.free_spins_win_count_text_line, impl.free_spins_win_payout_text_line)
  
  if impl.event_handler and impl.event_handler.OnShowFreeSpinsWin then
    impl.event_handler.OnShowFreeSpinsWin (state)
  end
  
  if state then
    PlayStoredSound (impl.free_spins_end_sound)
  else
    StopStoredSound (impl.free_spins_end_sound)
  end

  if not state then
    ApplicationDataSet (FREE_SPINS_GAIN, nil)
    impl.free_spins_started = false
  end

  ShowFreeSpinsLabel (impl, false)
end

local function ShowFreeSpinsLoose (impl, state)
  SetSpritesActive (state, unpack (impl.free_spins_results_sprites))
  SetSpritesActive (state, unpack (impl.free_spins_loose_sprites))
  
  SetTextLinesActive (state, unpack (impl.free_spins_loose_text_lines))
  
  if impl.event_handler and impl.event_handler.OnShowFreeSpinsLoose then
    impl.event_handler.OnShowFreeSpinsLoose (state)
  end
  
  if state then
    PlayStoredSound (impl.free_spins_end_sound)
  else
    StopStoredSound (impl.free_spins_end_sound)
  end

  if not state then
    ApplicationDataSet (FREE_SPINS_GAIN, nil)
    impl.free_spins_started = false
  end
  
  ShowFreeSpinsLabel (impl, false)
end

local function HideFreeSpinsResults (impl)
  game.scripts.boosters_overlay.SetState (true)

  ShowFreeSpinsWin (impl, false)
  ShowFreeSpinsLoose (impl, false)

  if not impl.bonus_occured and not impl.needs_choose_free_spins then
    SetUiState (impl, true)
  end
  
  if impl.event_handler and impl.event_handler.OnFreeSpinsResultsHide then
    impl.event_handler.OnFreeSpinsResultsHide (impl.bonus_occured, impl.needs_choose_free_spins)
  end

  game.scripts.ui_windows.ShowFreeSpinsEndedWindow ()
  
  impl.AnimateAllWinLines ()
end

local function ShowFreeSpinsResults (impl)
  impl.active_lines = math.min (impl.active_lines, impl.lines_count)

  if impl.total_free_spins_payout > 0 then  --win
    ShowFreeSpinsWin (impl, true)
  else                                      --loose
    ShowFreeSpinsLoose (impl, true)
  end

  SetUiState (impl, false)
  
  game.scripts.boosters_overlay.SetState (false)

  DelayedAction ("default", 5, function ()
    System.Application.ScreenSaverState = true
  end)
  
  impl.total_free_spins_count  = nil
  impl.total_free_spins_payout = nil
end

local function UpdateFreeSpinsLabel (impl)
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if impl.free_spins > 0 and not impl.double_occured and free_spins_allowed then
    ShowFreeSpinsLabel (impl, true) 
  
    if impl.free_spins_count_text_line then
      impl.free_spins_count_text_line.node.Text = tostring (impl.free_spins)
    end
  else
    ShowFreeSpinsLabel (impl, false) 
  end
  
  if impl.event_handler and impl.event_handler.OnFreeSpinsCountChanged then
    impl.event_handler.OnFreeSpinsCountChanged (impl.phone_ui, impl.free_spins)
  end
end

local_methods.ResumeFreeSpins = function (impl) 
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if impl.free_spins <= 0 or impl.bonus_occured or impl.needs_choose_free_spins or not free_spins_allowed then return end
  
  SetUiState (impl, not impl.bonus_occured and impl.free_spins == 0 and not impl.total_free_spins_count and not impl.needs_choose_free_spins)
  
  UpdateFreeSpinsLabel (impl)
  
  impl.free_spins_started = true
    
  DelayedAction ("default", impl.free_spins_auto_play_delay, function ()
    Play (impl, nil, true)
  end)
end

local function AddFreeSpinsWithAnimation (impl, add_value)
  local previous_value = impl.free_spins
 
  impl.free_spins = impl.free_spins + add_value
  
  UpdateFreeSpinsLabel (impl)
  
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if impl.free_spins > 0 and free_spins_allowed then
    impl.free_spins_count_text_line.node.Text = tostring (previous_value)

    SetNumberInStringSlowly (impl.free_spins_count_text_line, previous_value, impl.free_spins, 0.5)    
  end
end

local function OnGiftsSent (impl)
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if impl.free_spins <= 0 or impl.bonus_occured or impl.needs_choose_free_spins or not free_spins_allowed then return end
  
  impl.free_spins_started = true
    
  DelayedAction ("default", impl.free_spins_auto_play_delay, function ()
    Play (impl, nil, true)
  end)
  
  System.Application.ScreenSaverState = false
  
  UpdateFreeSpinsLabel (impl)
end

local function OnLinesAnimationEnded (impl)
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  local can_start_free_spins = impl.free_spins > 0 and not impl.double_occured and not impl.needs_choose_free_spins and free_spins_allowed

  if impl.bonus_occured then
    local bonus_screen = impl.bonus_screen
  
    HsConnectionSendStoredMessage (BONUS_INIT_MESSAGE, 1, { event = "bonus.init", slotId = impl.slot_id },
      function ()
        SetSlotScreen (bonus_screen, true)
      end)
    SetSlotScreen (bonus_screen)
  elseif impl.total_free_spins_count and impl.total_free_spins_payout then
    ShowFreeSpinsResults (impl)
  elseif can_start_free_spins or (impl.current_has_more_autospins and not impl.autospin_paused) then
    if can_start_free_spins then
      impl.free_spins_started = true
    end
    
    SetUiState (impl, false)

    impl.lines_animation_ended_play_action = DelayedAction ("default", impl.free_spins_auto_play_delay, function ()
      impl.lines_animation_ended_play_action = nil
      Play (impl, nil, true)
    end)
  else
    return false
  end

  return true
end

local function OnDoubleWindowClosed (impl)
  impl.double_occured = false
  
  OnLinesAnimationEnded (impl)
  UpdateFreeSpinsLabel (impl)
end

local_methods.AnimateWinLine = function (impl, line_index)
  StopWinAnimation (impl)

  local win_line = impl.win_lines [line_index]
    
  for i = 1, #win_line.line_sprites do
    win_line.line_sprites [i]:BindToParent (impl.win_animations_node)
  end

  for i = 1, #impl.win_lines do
    local line = impl.win_lines [i]

    if line.win_table_line then
      line.win_table_selected_line:Unbind ()
      line.win_table_line:BindToParent (line.win_table_node)
    end
  end

  if win_line.win_table_line then
    win_line.win_table_line:Unbind ()
    win_line.win_table_selected_line:BindToParent (win_line.win_table_node)
  end

  impl.win_animations = {}

  local max_animation_duration = 0
  
  local symbol_sound
  
  for i = 1, #win_line.symbols do
    local symbol = GetWinSymbol (impl, win_line.symbols [i])

    if symbol.desc.animation then
      local animation = symbol.desc.animation.CreateInstance (impl.win_animations_node)
      local position  = symbol.sprite.WorldPosition
      
      symbol.sprite.Alpha = 0
      
      animation.SetPosition (position.x, position.y, impl.animations_z)
      animation.Show ("animate")
      animation.Enqueue ("stay", function ()
        symbol.sprite.Alpha = 1
      end)
      
      max_animation_duration = math.max (max_animation_duration, animation.GetAnimationDuration ("animate"))
      
      table.insert (impl.win_animations, { animation = animation, symbol = symbol }) 
    end    
    
    if impl.animate_results_count < 3 and symbol.desc.sound ~= "" and (not symbol_sound or not symbol.desc.wild) then
      symbol_sound = symbol.desc.sound
    end
  end
  
  if symbol_sound then
    impl.current_symbol_sound = symbol_sound
        
    PlayStoredSound (symbol_sound)
  end
  
  local line_animation_duration = LINE_ANIMATION_DURATION
  
  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if (impl.total_free_spins_count or impl.free_spins > 0) and free_spins_allowed then
    line_animation_duration = FREE_SPINS_LINE_ANIMATION_DURATION
  end
  
  local animation_duration = math.max (line_animation_duration, max_animation_duration)
  
  if animation_duration % LINE_ANIMATION_PERIOD > EPS then
    animation_duration = animation_duration + LINE_ANIMATION_PERIOD - animation_duration % LINE_ANIMATION_PERIOD
  end
  
  impl.animate_win_action = SlowAction ("default", animation_duration, function (t)
    local phase = t * animation_duration / LINE_ANIMATION_PERIOD % 1

    UpdateLineAnimation (impl, line_index, phase, true)

    if t == 1 then
      if impl.bonus_occured then
        OnLinesAnimationEnded (impl)
      elseif impl.needs_choose_free_spins then
        local dim_symbols = {}
        
        for i = 0, 14 do
          local dim_symbol = true
        
          for j = 1, #impl.needs_choose_free_spins.symbols do
            if impl.needs_choose_free_spins.symbols [j].index == i then
              dim_symbol = false
              break
            end
          end
          
          if dim_symbol then
            table.insert (dim_symbols, i)
          end
        end
        
        DimSymbols (impl, dim_symbols)
        
        ShowWinTable (impl, false)

        if impl.event_handler and impl.event_handler.ShowChooseFreeSpins then
          impl.event_handler.ShowChooseFreeSpins (impl.needs_choose_free_spins.symbols, impl.animations_z)
        end
      elseif impl.new_free_spins_added then
        UpdateFreeSpinsLabel (impl)
        Play (impl, nil, true)
      elseif line_index < #impl.win_lines then
        local_methods.AnimateWinLine (impl, line_index + 1)
      else
        -- next cycle
        if not OnLinesAnimationEnded (impl) then
          impl.AnimateAllWinLines ()
        end
      end

      return
    end  
  end)

  UpdateLineAnimation (impl, line_index, 0, true)
end

local function AnimateAllWinLines (impl)
  if #impl.win_lines < 1 then
    UpdateLinesButtonsState (impl)
    OnLinesAnimationEnded (impl)
    return 
  end 
  
  impl.animate_results_count = impl.animate_results_count + 1
  
  StopWinAnimation (impl)

  for i = 1, #impl.win_lines do
    local line = impl.lines [impl.win_lines [i].line]
    
    if line then
      for j = 1, #line.line_sprites do
        line.line_sprites [j]:BindToParent (impl.win_animations_node)
      end
    end
  end

  for i = 1, #impl.win_lines do
    local line = impl.win_lines [i]

    if line.win_table_line then
      line.win_table_line:Unbind ()
      line.win_table_selected_line:BindToParent (line.win_table_node)
    end
  end
  
  local line_animation_duration = LINE_ANIMATION_DURATION
  
  if (impl.total_free_spins_count or impl.free_spins > 0) and not impl.new_free_spins_added then
    line_animation_duration = FREE_SPINS_LINE_ANIMATION_DURATION
  end
  
  impl.animate_win_action = SlowAction ("default", line_animation_duration, function (t)
    local phase = t * line_animation_duration / LINE_ANIMATION_PERIOD % 1

    for i = 1, #impl.win_lines do
      UpdateLineAnimation (impl, i, phase)
    end

    if t == 1 then
      local free_spins_allowed = true

      if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
        free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
      end

      if impl.total_free_spins_count and impl.total_free_spins_payout then
        ShowFreeSpinsResults (impl)
      elseif impl.bonus_occured then
        local bonus_line_index = 1
          
        for i = 1, #impl.win_lines do
          if impl.win_lines [i].type == 2 then
            bonus_line_index = i
            break
          end 
        end
        
        local_methods.AnimateWinLine (impl, bonus_line_index)        
      elseif impl.new_free_spins_added or impl.needs_choose_free_spins then
        local scatter_line_index = 1
          
        for i = 1, #impl.win_lines do
          if impl.win_lines [i].type == 3 then
            scatter_line_index = i
            break
          end 
        end
        
        local_methods.AnimateWinLine (impl, scatter_line_index)
      elseif (impl.free_spins > 0 and impl.free_spins_started and free_spins_allowed) or (impl.current_has_more_autospins and not impl.autospin_paused) then
        Play (impl, nil, true)
      elseif impl.battle_active then
        AnimateAllWinLines (impl)  
      else
        local_methods.AnimateWinLine (impl, 1)
      end
      
      return
    end
  end)
end

local function SetSlotVisible (impl, state) 
  if state then
    if impl.win_table_node then
      impl.win_table_node:BindToParent (game.current_screen.node)
      
      if impl.win_table_opened then
        ActivateSprite (impl.win_close_button)
        game.scripts.buttons.SetButtonActive (impl.win_close_button.name, true, true)
      else
        ActivateSprite (impl.win_open_button)
        game.scripts.buttons.SetButtonActive (impl.win_open_button.name, true, true)
      end
    end

    impl.spin_engine.BindReels ()
    
    impl.win_animations_node:BindToParent (game.current_screen.node)

    UpdateLinesButtonsState (impl)
  else
    if impl.win_table_node then
      impl.win_table_node:Unbind ()

      impl.win_table_opened = IsSpriteActive (impl.win_close_button)

      DeactivateSprite (impl.win_close_button)
      DeactivateSprite (impl.win_open_button)
      
      game.scripts.buttons.SetButtonActive (impl.win_close_button.name, false, true)
      game.scripts.buttons.SetButtonActive (impl.win_open_button.name, false, true)
    end

    impl.spin_engine.UnbindReels ()

    for i = 1, #impl.lines do
      local line = impl.lines [i]
  
      SetSpritesActive (false, line.left_disabled, line.right_disabled, line.left_enabled, line.right_enabled)
    end                 

    impl.win_animations_node:Unbind ()
  end
end

local function PaymentTable (impl)
  if impl.active_paytable_page then
    if impl.win_table_node then
      impl.win_table_node:BindToParent (game.current_screen.node)
      
      if impl.win_table_opened then
        ActivateSprite (impl.win_close_button)
        game.scripts.buttons.SetButtonActive (impl.win_close_button.name, true, true)
      else
        ActivateSprite (impl.win_open_button)
        game.scripts.buttons.SetButtonActive (impl.win_open_button.name, true, true)
      end
    end

    SetUiState (impl, true)
   
    ShowPaymentTablePage (impl, false)
    
    impl.active_paytable_page = nil

    impl.spin_engine.BindReels ()
    impl.win_animations_node:BindToParent (game.current_screen.node)
    
    UpdateLinesButtonsState (impl)
    
    if impl.boosters_panel_shown_before_paytable and not game.scripts.boosters_overlay.IsShown () then
      game.scripts.boosters_overlay.Show ()
    end
  else
    impl.boosters_panel_shown_before_paytable = game.scripts.boosters_overlay.IsShown ()

    if impl.boosters_panel_shown_before_paytable then
      game.scripts.boosters_overlay.Show ()
    end
  
    if impl.win_table_node then
      impl.win_table_node:Unbind ()

      impl.win_table_opened = IsSpriteActive (impl.win_close_button)

      DeactivateSprite (impl.win_close_button)
      DeactivateSprite (impl.win_open_button)

      game.scripts.buttons.SetButtonActive (impl.win_close_button.name, false, true)
      game.scripts.buttons.SetButtonActive (impl.win_open_button.name, false, true)
    end
  
    SetUiState (impl, false)
       
    ActivateSprite (impl.payment_table_button_enabled)
    DeactivateSprite (impl.payment_table_button_disabled)
    
    SetTextLinesActive (true, unpack (impl.payment_table_line_active))
    SetTextLinesActive (false, unpack (impl.payment_table_line_passive))
  
    impl.active_paytable_page = 1

    ShowPaymentTablePage (impl, true)  

    impl.spin_engine.UnbindReels ()

    for i = 1, #impl.lines do
      local line = impl.lines [i]
  
      SetSpritesActive (false, line.left_disabled, line.right_disabled, line.left_enabled, line.right_enabled)
    end                 

    impl.win_animations_node:Unbind ()
  end

  if impl.event_handler and impl.event_handler.OnPaymentTableOpened then
    impl.event_handler.OnPaymentTableOpened (impl.active_paytable_page ~= nil)
  end
end

local function SetWinValue (impl, new_value, immediate)
  if immediate then
    impl.win_text_line.node.Text = FormatMoneyString (new_value, impl.payout_max_symbols_count, new_value % 100 ~= 0, true)
  else
    SetNumberInStringSlowly (impl.win_text_line, impl.last_win_value, new_value, nil, function (value)
      return FormatMoneyString (value, impl.payout_max_symbols_count, new_value % 100 ~= 0, true)
    end, function ()
      if impl.last_win_value == 0 then
        DelayedAction ("default", 0.5, function ()
          impl.win_text_line.node.Text = FormatMoneyString (0)
        end)
      end
    end)
  end
  
  impl.last_win_value = new_value
end

local function RemoveBonusIconsHighlight (impl)
  if not impl.highlighted_symbols then return end

  for i = 1, #impl.highlighted_symbols do
    local symbol = impl.highlighted_symbols [i]
    
    symbol.highlighted_sprite:Unbind ()
    symbol.highlighted_sprite = nil
  end

  impl.highlighted_symbols = {}
end

local function FindBonusSymbolOnReel (impl, reel_index)
  local reel = impl.reels [reel_index]
  
  for i = 0, 2 do
    local item = reel.items [i + reel.stop_position]
      
    if item.desc.index == 0 then
      return item
    end
  end

  return nil  
end

local function OnReelStopInitiated (impl, reel_index) 
  if impl.bonus_mode == 1 then   --highlight bonus icons
    local bonus_symbol = FindBonusSymbolOnReel (impl, reel_index)
    
    if not bonus_symbol then return end
    
    impl.bonus_icons_count = impl.bonus_icons_count + 1
    
    if (#impl.reels - reel_index) + impl.bonus_icons_count < 3 then  --bonus impossible
      return
    end

    if reel_index == #impl.reels then return end

    if impl.bonus_icons_count > 1 then
      impl.needs_play_bonus_yes_no_sound = true
    
      impl.spin_engine.PrepareForBonusTurboMode ()
    end
  end 
end

local function OnReelSpinStopped (impl, reel_index)
  if impl.event_handler and impl.event_handler.OnReelSpinStopped then
    impl.event_handler.OnReelSpinStopped (reel_index)
  end

  if impl.bonus_mode == 1 then   --highlight bonus icons
    local bonus_symbol = FindBonusSymbolOnReel (impl, reel_index)

    if bonus_symbol then
      impl.stopped_bonus_icons_count = impl.stopped_bonus_icons_count + 1
    end
       
    if (#impl.reels - reel_index) + impl.stopped_bonus_icons_count < 3 then  --bonus impossible
      RemoveBonusIconsHighlight (impl)
      return
    end
    
    if impl.bonus_icons_count > 1 and reel_index > 1 and reel_index < #impl.reels and impl.event_handler and impl.event_handler.OnReelStopStartedWithPossibleBonus then
      impl.event_handler.OnReelStopStartedWithPossibleBonus (reel_index + 1)
    end

    if not bonus_symbol then return end
    
    PlaySound ("bonus_highlight_" .. impl.stopped_bonus_icons_count)
    
    if reel_index == #impl.reels then return end
    
    if bonus_symbol.desc.highlighted_material then
      local highlighted_sprite = Scene.Sprite.Create ()
      
      highlighted_sprite.Position  = vec3 (0, 0, -10 * EPS)
      highlighted_sprite.Material  = bonus_symbol.desc.highlighted_material
      highlighted_sprite.TexSize   = bonus_symbol.desc.highlighted_tex_size
      highlighted_sprite.TexOffset = bonus_symbol.desc.highlighted_tex_offset
      highlighted_sprite.Alpha     = 0
      
      highlighted_sprite:BindToParent (bonus_symbol.sprite)
      
      if bonus_symbol.highlighted_sprite then
        print ("ERROR: symbol already has highlighted sprite")
      end
      
      bonus_symbol.highlighted_sprite = highlighted_sprite
      
      table.insert (impl.highlighted_symbols, bonus_symbol)
    end
    
    if impl.bonus_icons_count > 1 then
      impl.spin_engine.ActivateBonusTurboMode ()
    end
  end 
end

local function UpdateBattleInfoOverlay (impl)
  SetSpritesActive (impl.battle_user_money > impl.battle_opponent_money, "battle_overlay_player_leader_stroke" .. impl.battle_overlay_suffix, "battle_overlay_player_first_progress_bar" .. impl.battle_overlay_suffix, "battle_overlay_opponent_second_progress_bar" .. impl.battle_overlay_suffix)
  SetSpritesActive (impl.battle_user_money < impl.battle_opponent_money, "battle_overlay_opponent_leader_stroke" .. impl.battle_overlay_suffix, "battle_overlay_opponent_first_progress_bar" .. impl.battle_overlay_suffix, "battle_overlay_player_second_progress_bar" .. impl.battle_overlay_suffix)
  
  local leader_color = vec4 (60 / 255, 218 / 255, 37 / 255, 1)
  local looser_color = vec4 (1, 0, 0, 1)
  local draw_color   = vec4 (0.569, 0.525, 0.596, 1)
  
  if impl.battle_user_money > impl.battle_opponent_money then
    GetTextLine ("battle_overlay_player_score" .. impl.battle_overlay_suffix).node.Color   = leader_color 
    GetTextLine ("battle_overlay_opponent_score" .. impl.battle_overlay_suffix).node.Color = looser_color 
  elseif impl.battle_user_money < impl.battle_opponent_money then
    GetTextLine ("battle_overlay_player_score" .. impl.battle_overlay_suffix).node.Color   = looser_color 
    GetTextLine ("battle_overlay_opponent_score" .. impl.battle_overlay_suffix).node.Color = leader_color
  else
    GetTextLine ("battle_overlay_player_score" .. impl.battle_overlay_suffix).node.Color   = draw_color 
    GetTextLine ("battle_overlay_opponent_score" .. impl.battle_overlay_suffix).node.Color = draw_color 
  end
  
  local new_user_money     = impl.battle_user_money
  local new_opponent_money = impl.battle_opponent_money
  
  if impl.battle_progress_bar_update_action then
    impl.battle_progress_bar_update_action.Stop ()
  end
  
  local player_prev_progress_value   = impl.player_progress_value
  local opponent_prev_progress_value = impl.opponent_progress_value
  local player_new_progress_value
  local opponent_new_progress_value
  
  if impl.battle_type == 0 then
    local total_money = new_user_money + new_opponent_money
  
    player_new_progress_value   = new_user_money / total_money
    opponent_new_progress_value = new_opponent_money / total_money
  else
    player_new_progress_value   = new_user_money / impl.battle_win_money
    opponent_new_progress_value = new_opponent_money / impl.battle_win_money
  end
  
  local player_scissor_left_start    = impl.battle_player_progress_scissor.left + (1 - player_prev_progress_value) * impl.battle_player_progress_scissor.width
  local player_scissor_left_end      = impl.battle_player_progress_scissor.left + (1 - player_new_progress_value) * impl.battle_player_progress_scissor.width
  local player_scissor_width_start   = player_prev_progress_value * impl.battle_player_progress_scissor.width
  local player_scissor_width_end     = player_new_progress_value * impl.battle_player_progress_scissor.width
  local opponent_scissor_width_start = opponent_prev_progress_value * impl.battle_opponent_progress_scissor.width
  local opponent_scissor_width_end   = opponent_new_progress_value * impl.battle_opponent_progress_scissor.width
  
  impl.battle_progress_bar_update_action = SlowAction ("ui", BATTLE_PROGRESS_UPDATE_DURATION, function (t)
    impl.player_progress_value   = player_prev_progress_value + t * (player_new_progress_value - player_prev_progress_value)
    impl.opponent_progress_value = opponent_prev_progress_value + t * (opponent_new_progress_value - opponent_prev_progress_value)
  
    local player_scissor_left    = player_scissor_left_start + t * (player_scissor_left_end - player_scissor_left_start)
    local player_scissor_width   = player_scissor_width_start + t * (player_scissor_width_end - player_scissor_width_start)
    local opponent_scissor_left  = impl.battle_opponent_progress_scissor.left
    local opponent_scissor_width = opponent_scissor_width_start + t * (opponent_scissor_width_end - opponent_scissor_width_start)
    local camera_height          = impl.camera.Top - impl.camera.Bottom
  
    if impl.battle_user_money > impl.battle_opponent_money then
      BindOrUpdateScissor (GetSprite ("battle_overlay_player_first_progress_bar" .. impl.battle_overlay_suffix), player_scissor_left, 0, player_scissor_width, camera_height)
      BindOrUpdateScissor (GetSprite ("battle_overlay_opponent_second_progress_bar" .. impl.battle_overlay_suffix), opponent_scissor_left, 0, opponent_scissor_width, camera_height)
    else
      BindOrUpdateScissor (GetSprite ("battle_overlay_player_second_progress_bar" .. impl.battle_overlay_suffix), player_scissor_left, 0, player_scissor_width, camera_height)
      BindOrUpdateScissor (GetSprite ("battle_overlay_opponent_first_progress_bar" .. impl.battle_overlay_suffix), opponent_scissor_left, 0, opponent_scissor_width, camera_height)
    end
  end)
  
  SetNumberInStringSlowly ("battle_overlay_player_score" .. impl.battle_overlay_suffix, impl.last_battle_user_money, new_user_money, BATTLE_PROGRESS_UPDATE_DURATION, function (val)
    return FormatMoneyString (val, BATTLE_OVERLAY_USER_SCORE_VALUE_SYMBOLS_COUNT, new_user_money % 100 ~= 0)
  end)
  
  SetNumberInStringSlowly ("battle_overlay_opponent_score" .. impl.battle_overlay_suffix, impl.last_battle_opponent_money, new_opponent_money, BATTLE_PROGRESS_UPDATE_DURATION, function (val)
    return FormatMoneyString (val, BATTLE_OVERLAY_USER_SCORE_VALUE_SYMBOLS_COUNT, new_opponent_money % 100 ~= 0)
  end)
  
  impl.last_battle_opponent_money = impl.battle_opponent_money
  impl.last_battle_user_money     = impl.battle_user_money
end

local function ShowBattleResult (impl)
  SetUiState (impl, false)
 
  if impl.new_opponent_money then
    impl.battle_opponent_money = impl.new_opponent_money
    
    for i = 1, #impl.battle_info_opponent_update_actions do
      impl.battle_info_opponent_update_actions [i].Stop ()
    end
    
    impl.battle_info_opponent_update_actions = {}
    
    UpdateBattleInfoOverlay (impl)
  end

  DelayedAction ("ui", SHOW_BATTLE_RESULTS_DELAY, function ()
    if impl.battle_result.status == 0 then
      game.scripts.ui_windows.ShowBattleWinWindow (impl.battle_result.money, impl.battle_result.rating, impl.battle_result.interrupted)
    elseif impl.battle_result.status == 1 then
      game.scripts.ui_windows.ShowBattleLoseWindow ()
    else
      game.scripts.ui_windows.ShowBattleDrawWindow (impl.battle_result.money)
    end
  end)
end

local function ShowLevelUpWindow (impl)
  if impl.battle_active then
    local user_level = GetUserLevel ()

    local replacements = {
      { token = "{level}",  replacement = tostring (user_level.id) },
      { token = "{coins}",  replacement = FormatMoneyString (user_level.bonus.coins, 6) },
      { token = "{diamonds}",  replacement = tostring (user_level.bonus.diamonds) }
    }

    local info_texts = {}

    for i = 1, 3 do
      table.insert (info_texts, ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.LEVEL_UP_LINE_" .. i), replacements))
    end

    game.scripts.ui_windows.ShowBattleInfoWindow ("battle_info_window_level_up", GetLocalizedString ("BATTLE_INFO_WINDOW.LEVEL_UP_TITLE"), info_texts)
    
    local slots = ApplicationDataGet (SLOTS_DESCS)

    for i = 1, #slots do
      local slot_desc = slots [i]

      if slot_desc.id and slot_desc.level and slot_desc.level + 0 == user_level.id + 0 and not slot_desc.coming_soon then
        local replacements = {
          { token = "{game}", replacement = slot_desc.game_name }
        }

        local info_texts = {}

        for i = 1, 3 do
          table.insert (info_texts, ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.NEW_GAME_LINE_" .. i), replacements))
        end

        game.scripts.ui_windows.ShowBattleInfoWindow ({ material = slot_desc.icon_material, scale = vec3 (1, 1, 1), additional_resources = { slot_desc.xmtl_path }, force_scale_multiplier = vec3 (1.5, 1.5, 1) }, 
          GetLocalizedString ("BATTLE_INFO_WINDOW.NEW_GAME_TITLE"), info_texts)
        
        break
      end
    end
    
    local battles = GetBattles ()

    for i = 1, #battles do
      local battle = battles [i]
    
      for j = 1, 3 do
        local mode = battle.modes [j]
    
        if mode.level == user_level.id then
          local slot_name = ""

          for k = 1, #slots do
            local slot_desc = slots [k]

            if slot_desc.id and slot_desc.id + 0 == battle.slot_id then
              slot_name = slot_desc.game_name
              break
            end
          end
        
          local replacements = {
            { token = "{battle}", replacement = slot_name },
            { token = "{type}",   replacement = GetLocalizedString ("BATTLES_WINDOW.BATTLE_" .. j .. "_TITLE") }
          }

          local info_texts = {}

          for i = 1, 3 do
            table.insert (info_texts, ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.NEW_BATTLE_LINE_" .. i), replacements))
          end

          game.scripts.ui_windows.ShowBattleInfoWindow ("battle_info_window_new_battle", GetLocalizedString ("BATTLE_INFO_WINDOW.NEW_BATTLE_TITLE"), info_texts)
        end
      end
    end
  else
    game.scripts.ui_windows.ShowLevelUpWindow ()
  end
end

local function ShowFiveInRowWindow (impl, symbol)
  local item = impl.items [impl.items_list [symbol]]

  if impl.battle_active then
    game.scripts.ui_windows.ShowBattleInfoWindow ({ material = item.material, scale = item.scale }, 
      GetLocalizedString ("INFO_WINDOW.SHARE_FIVE_IN_ROW_TITLE_LINE1"), { GetLocalizedString ("INFO_WINDOW.SHARE_FIVE_IN_ROW_TEXT_LINE1") })
  else
    game.scripts.ui_windows.ShowFiveInRowWindow (item.material, item.tex_size, item.tex_offset, item.scale, impl.five_in_row_payout, GetVarValue (game.current_screen.vars, 'share_symbol_hs_path') or impl.hs_path, symbol - 1)
  end
end

local function ShowQueuedAchievements (impl)
  for i = 1, #impl.achievement_complete_queue do
    local achievement_data = impl.achievement_complete_queue [i]

    if achievement_data.group then
      if impl.battle_active then
        local replacements = { { token = "{group}", replacement = GetLocalizedString ("ACHIEVEMENTS_WINDOW.ACHIEVEMENT_TITLE_" .. achievement_data.data.id) } }
        local line_1       = ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_GROUP_LINE_1"), replacements)
        local line_2       = ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_GROUP_LINE_2"), replacements)
        local line_3       = ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_GROUP_LINE_3"), replacements)        
      
        game.scripts.ui_windows.ShowBattleInfoWindow ("battle_info_window_achievement_group", GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_GROUP_TITLE"), { line_1, line_2, line_3 })
      else
        game.scripts.ui_windows.ShowAchievementsGroupComplete (achievement_data.data.id, achievement_data.data.prize, achievement_data.data.prize_type)
      end
    else
      if impl.battle_active then
        game.scripts.ui_windows.ShowBattleInfoWindow ("battle_info_window_achievement", 
        GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_TITLE"), { GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_LINE_1"), GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_LINE_2"), GetLocalizedString ("BATTLE_INFO_WINDOW.ACHIEVEMENT_LINE_3") })
      else
        game.scripts.ui_windows.ShowAchievementsCompleteWindow (achievement_data.data.id, achievement_data.data.group_id, achievement_data.data.current, achievement_data.data.prize_type)
      end
    end
  end
  
  impl.achievement_complete_queue = {}
end

local_methods.SetHasMoreAutoSpins = function (impl, state)
  impl.has_more_autospins = state 
end

local_methods.ResetAutoSpins = function (impl) 
  impl.current_has_more_autospins = nil
  impl.has_more_autospins = nil
  
  game.scripts.boosters_overlay.ResetAutoSpins ()
end

local function OnSpinFinished (impl)
  if not impl.needs_choose_free_spins and impl.free_spins == 0 then
    impl.active_lines = math.min (impl.active_lines, impl.lines_count)
  end

  if impl.bonus_occured or impl.needs_choose_free_spins or impl.new_free_spins_added then
    local_methods.ResetAutoSpins (impl)
  end

  impl.double_bet_active = false

  game.scripts.top_ui.SetDiamondsAutoUpdate (true)

  RemoveBonusIconsHighlight (impl)

  if impl.show_level_up_window then
    impl.five_in_row_symbol = nil
    impl.show_level_up_window = false
    
    ShowLevelUpWindow (impl)
  end  

  if impl.last_slot_spin_response then
    OnBetUpdated (impl, impl.last_slot_spin_response)
  end

  impl.spin_started = false
  impl.needs_stop_spinning = false
  
  if impl.five_in_row_symbol then
    ShowFiveInRowWindow (impl, impl.five_in_row_symbol)

    impl.five_in_row_symbol = nil
  end
  
  local_methods.ShowQueuedTopNotifications (impl)
  ShowQueuedAchievements (impl)
  
  SetUiState (impl, not impl.bonus_occured and impl.free_spins == 0 and not impl.total_free_spins_count and not impl.needs_choose_free_spins and not (impl.current_has_more_autospins and not impl.autospin_paused) and not (impl.battle_active and not impl.battle_started))
  
  if not impl.game_started or (not impl.new_free_spins_added) then
    UpdateFreeSpinsLabel (impl)
  end
      
--  impl.total_payout = 88888888800  --DEBUG

  SetWinValue (impl, impl.total_payout)      
  
  if impl.total_payout > 0 then
    UpdateBalanceText (impl)
  end
  
  impl.animate_results_count = 0
  
  ShowWinTable (impl, true)
  
  if impl.mega_spins_activated then
    DeactivateSprites (unpack (impl.mega_lines_show_sprites))
    DeactivateTextLines (unpack (impl.mega_lines_show_text_lines))
    ActivateSprites (unpack (impl.mega_lines_hide_sprites))
    ActivateTextLines (unpack (impl.mega_lines_hide_text_lines))

    UpdateLinesButtonsState (impl)
    
    impl.mega_spins_activated = false
  end
  
  AnimateAllWinLines (impl)
  
  if impl.event_handler and impl.event_handler.OnWideSymbolOccured then
    for i = 1, #impl.wide_reels do
      if impl.wide_reels [i] then
        impl.event_handler.OnWideSymbolOccured (i)
        
        --hide symbols for this reel
        local reel = impl.reels [i]
        
        for j = 1, #reel.items do
          local item = reel.items [j]
    
          item.sprite.Alpha = 0
        end
      end
    end
  end
  
  if impl.event_handler and impl.event_handler.OnSpinFinished then
    impl.event_handler.OnSpinFinished (#impl.win_lines > 0, impl.bonus_occured, impl.total_free_spins_count, impl.needs_choose_free_spins)
  end
  
  if impl.game_started and impl.total_payout > 0 and not impl.bonus_occured and impl.free_spins == 0 and not ApplicationDataGet (FREE_SPINS_GAIN) and   
     impl.event_handler and impl.event_handler.OnDoubleAvailable and not impl.needs_choose_free_spins and not (impl.current_has_more_autospins and not impl.autospin_paused) then
    impl.event_handler.OnDoubleAvailable ()
  end
  
  if impl.battle_active then
    impl.battle_user_money = impl.battle_user_new_money
  
    if impl.battle_user_money ~= impl.last_battle_user_money then
      UpdateBattleInfoOverlay (impl)
    end
  end

  if impl.battle_result then
    ShowBattleResult (impl)
  end

  local play_win_sound = impl.total_payout > 0
  
  if game.scripts.boosters_overlay then
    if game.scripts.boosters_overlay.OnSpinFinished (impl.total_payout) then
      play_win_sound = false
    end
  end
  
  game.scripts.top_ui.OnSpinFinished (impl.bet.money * impl.active_lines, impl.total_payout)
  
  local win_sound_delay
  
  if impl.needs_play_bonus_yes_no_sound then
    if impl.bonus_occured then
      if impl.bonus_yes_sound then
        PlaySound (impl.bonus_yes_sound)
        win_sound_delay = impl.bonus_yes_sound_duration
      end
    else
      if impl.bonus_no_sound then
        PlaySound (impl.bonus_no_sound)
        win_sound_delay = impl.bonus_no_sound_duration
      end
    end
  end

  if play_win_sound and #impl.win_lines > 0 and impl.game_started then
    if win_sound_delay then
      DelayedAction ("default", win_sound_delay, function ()
        PlaySound (impl.win_sound)
      end)
    else
      PlaySound (impl.win_sound)
    end
  end
end

local function Update (impl)
  impl.spin_engine.Update ()
  
  if impl.spin_started then
    local spin_time = game.current_screen.timers.default:GetTime () - impl.spin_start_time

    if impl.highlighted_symbols then
      local highlight_amount = (spin_time % HIGHLIGHT_PERIOD) / HIGHLIGHT_PERIOD

      if highlight_amount > HIGHLIGHT_HALF_PERIOD then
        highlight_amount = HIGHLIGHT_PERIOD - highlight_amount 
      end

      highlight_amount = highlight_amount / HIGHLIGHT_HALF_PERIOD

      for i = 1, #impl.highlighted_symbols do
        impl.highlighted_symbols [i].highlighted_sprite.Alpha = highlight_amount
      end
    end
  end
  
  if impl.battle_start_time then
    local current_time = game.main_timer.GetTime ()
    local battle_time  = current_time - impl.battle_start_time
    local left_time    = math.max (0, math.floor (impl.battle_duration - battle_time))

    if left_time < 6 and left_time > 0 and not impl.battle_time_ending_sound_playing then
      impl.battle_time_ending_sound_playing = true
      PlayStoredSound ("battle_time_ending")
    end
    
    if left_time == 0 and impl.battle_time_ending_sound_playing then
      impl.battle_time_ending_sound_playing = false
      StopStoredSound ("battle_time_ending")
      PlaySound ("battle_time_ending_started")
    end
    
    if impl.timer_animation and impl.battle_started then
      local timer_text_line = GetTextLine ("battle_overlay_timer")
    
      timer_text_line.node.Text = tostring (left_time)
      
      if left_time <= 5 then
        local alpha = math.abs (math.fmod (impl.battle_duration - battle_time, 0.5) - 0.25) * 4 
      
        alpha = alpha * 0.8 + 0.2
      
        timer_text_line.node.Color = vec4 (1, 0, 0, alpha)
      end
    end 
  end
end

local function OnSlotInit (impl, event)
  impl.bonus_mode     = GetNodeChildAttribute (event, "bonusMode", "0") + 0
  impl.double_occured = GetNodeChildAttribute (event, "double", "false") == "true"

  local show_bonus_icons = GetNodeChildAttribute (event, "showBonusIcons")
  
  if show_bonus_icons and show_bonus_icons == "true" then
    impl.bonus_mode = 1
  end

  OnBetUpdated (impl, event)

  local lines = event:Find ("lines"):Attribute (0) + 0 
  
  ActivateLines (impl, lines, false)
  
  local symbols_node         = event:Find ("symbols"):Child (0)
  local symbols_arrays_count = symbols_node.ChildrenCount

  if symbols_arrays_count ~= 5 then
    error ("invalid slot init format, unsupported symbols array count")
  end

  for i = 0, symbols_arrays_count - 1 do
    local array     = symbols_node:Child (i)
    local reel      = impl.reels [i + 1]
    local reel_node = reel.node
    
    reel.items = {}
    
    local reel_size = array.AttributesCount

    if reel_size < 3 then
      error ("invalid reel size")
    end 

    local items_count = reel_size + 3

    reel.items_groups = {}

    local groups_count = math.ceil (items_count / SYMBOLS_GROUP_SIZE)

    local group_height  = SYMBOLS_GROUP_SIZE * impl.line_interval
    local group_overlap = 5 * impl.line_interval

    for j = 1, groups_count do
      local group = {}
      
      group.node = Scene.Node.Create ()
      
      group.min_y = (j - 1) * group_height - group_overlap
      group.max_y = j * group_height
      
      table.insert (reel.items_groups, group)
    end

    for j = 0, reel_size + 2 do  -- add three additional symbols to the end of reel for cycled scrolling
      local item = {}

      item.desc = impl.items [impl.items_list [array:Attribute (j % reel_size) + 1] ]
      
      item.sprite = Scene.Sprite.Create ()
      
      item.sprite.Material   = item.desc.material
      item.sprite.Position   = vec3 (0, -j * impl.line_interval, 0)
      item.sprite.WorldScale = item.desc.scale
      item.sprite.TexSize    = item.desc.tex_size
      item.sprite.TexOffset  = item.desc.tex_offset
      
      item.blured_sprite = Scene.Sprite.Create ()
      
      item.blured_sprite.Material   = item.desc.blured_material
      item.blured_sprite.Position   = vec3 (0, -j * impl.line_interval, -EPS)
      item.blured_sprite.WorldScale = item.desc.blured_scale
      item.blured_sprite.TexSize    = item.desc.blured_tex_size
      item.blured_sprite.TexOffset  = item.desc.blured_tex_offset
      item.blured_sprite.Alpha      = 0
      
      table.insert (reel.items, item)
      
      local group = reel.items_groups [math.floor (j / SYMBOLS_GROUP_SIZE) + 1]
      
      item.sprite:BindToParent (group.node)
      item.blured_sprite:BindToParent (group.node)
    end

    reel.length = reel_size * impl.line_interval 
  end
  
  local scissor = CreateScissor (impl.reel_clip_zone.left, impl.reel_clip_zone.top, impl.reel_clip_zone.width, impl.reel_clip_zone.height)
  
  impl.spin_engine.SetReelsScissor (scissor)
  
  scissor:BindToScene (impl.camera.Scene)
  
  ParseReelsPositions (impl, event)
  
  for i = 1, #impl.reels do
    impl.spin_engine.ScrollReel (i, impl.reels [i].stop_position - 1)
  end

  --paytable

  impl.paytable = {}
  
  local paytable_node  = event:Find ("paytable"):Child (0)
  local paytable_count = paytable_node.ChildrenCount

  for i = 0, paytable_count - 1 do
    local table_node = paytable_node:Child (i)
    local id         = table_node:Find ("id"):Attribute (0) + 0
    local pays_node  = table_node:Find ("pays"):Child (0)
    local pays_count = pays_node.ChildrenCount

    if id == 0 then          --bonus
      for j = 0, pays_count - 1 do
        local pay_node = pays_node:Child (j)
        local count    = pay_node:Find ("count"):Attribute (0) + 0
        local win      = pay_node:Find ("win"):Attribute (0)
        local max_win  = pay_node:Find ("maxWin"):Attribute (0)

        if not impl.bonus_max_win then
          impl.bonus_max_win = max_win
        end
        
        local from_line
        local to_line
        
        if count == 5 then
          from_line = impl.bonus_paytable_from_5_text_line
          to_line   = impl.bonus_paytable_to_5_text_line
        elseif count == 4 then
          from_line = impl.bonus_paytable_from_4_text_line
          to_line   = impl.bonus_paytable_to_4_text_line
        elseif count == 3 then
          from_line = impl.bonus_paytable_from_3_text_line
          to_line   = impl.bonus_paytable_to_3_text_line
        else
          error ("Unsupported count for bonus game")
        end        

        if from_line then
          from_line.node.Text = FormatMoneyString (win * 100)
        end
        
        if to_line then
          to_line.node.Text = FormatMoneyString (max_win * 100)
        end
      end    
    else
      local lines = impl.symbols_paytable_lines [id]

      local symbol_paytable = {}

      if lines then
        for j = 0, pays_count - 1 do
          local pay_node = pays_node:Child (j)
          local count    = pay_node:Find ("count"):Attribute (0) + 0
          local win      = pay_node:Find ("win"):Attribute (0)
          local max_win  = GetNodeChildAttribute (pay_node, "maxWin", nil)

          if lines [count] then
            lines [count].node.Text = tostring (win)
          else
            print ("No line for symbol " .. id .. " count " .. count .. " !!!!!!!!!!!")
          end
          
          table.insert (symbol_paytable, { count = count, win = win, max_win = max_win })
        end
      end
      
      table.insert (impl.paytable, symbol_paytable)
    end
  end

  ParseWins (impl, event)
  
  SetProfileProperty (DONT_SHOW_BONUS_TUTORIAL_ATTRIBUTE, nil)

  OnSpinFinished (impl)
  
  if impl.double_occured then
    if impl.event_handler and impl.event_handler.OnSlotInitDoubleActive then
      impl.event_handler.OnSlotInitDoubleActive ()
    end
  end

  local slots = GetSlots ()
  local has_bonus_spins

  for i = 1, #slots do
    local slot_desc = slots [i]

    if slot_desc.id == impl.slot_id then
      has_bonus_spins = slot_desc.features [64] --TODO REPLACE WITH NAMED CONSTANT AFTER DEPRECATION OF OLD VERSION
      break
    end
  end
  
  if GetNodeChildAttribute (event, "isFirst", "false") == "true" and has_bonus_spins and impl.free_spins == 0 then
    ExecuteOnNextUpdate (function ()
      PaymentTable (impl)

      ShowPaymentTablePage (impl, false)
      impl.active_paytable_page = #impl.paytable_pages
      ShowPaymentTablePage (impl, true)
    end)
  end
  
  if impl.active_lines == 99 then
    ExecuteOnNextUpdate (function ()
      local_methods.ShowMegaLines (impl)
    end)
  end
end

local function OnDragSlots (impl, touch, y)
  local last_y = impl.drag_y

  if not last_y then return end 
  
  impl.drag_y = y  

  local dy = y - last_y
  
  local drag_enabled = IsSpriteActive (impl.play_button_enabled)
  local spin_params
  
  if impl.event_handler and impl.event_handler.IsDragForceEnabled and impl.event_handler.IsDragForceEnabled () then
    drag_enabled = true
  end
    
  if impl.event_handler.GetSpinParams then
    spin_params = impl.event_handler.GetSpinParams ()
  end
  
  if dy < -DRAG_THRESHOLD and drag_enabled then
    local turbo_booster_spins = 0

    local boosters = GetPowerups ()
  
    for i = 1, #boosters do
      local booster = boosters [i]
    
      if booster.id == 1 then
        turbo_booster_spins = booster.spins_left
        break
      end
    end

    if turbo_booster_spins > 0 then
      PlaySound ("battle_turbo_spin_click")
    elseif impl.swipe_sound_enabled then
      PlaySound (impl.spin_start_sound or "spin_click")
    end
     
    Play (impl, nil, true, spin_params)
  end  
end

local function OnDragSlotsStarted (impl, touch, y)
  impl.drag_y = y
end

local function OnDragSlotsEnded (impl, touch)
  impl.drag_y = nil
end

local function GetCellPosition (impl, line, reel)
  return impl.reels [reel].start_position - vec3 (0, impl.line_interval * (line - 1), 0)
end

local function GetColor (str)
  local return_value = StringToVec (str)

  return vec4 (return_value.x, return_value.y, return_value.z, 1)
end

local function GetColorOrNil (str)
  if str == "" then return nil end
  
  return GetColor (str)
end

local function OnUserLevelUp (impl)
  if impl.spin_started then
    impl.show_level_up_window = true
  else
    ShowLevelUpWindow (impl)
  end

  UpdateBalanceText (impl)

  return true
end

local function OnBattleInfoUpdated (impl, event)
  if not impl.battle_active then return end
  
  local users_node  = event:Find ("users"):Child (0)
  local users_count = users_node.ChildrenCount
  
  local new_opponent_money = impl.battle_opponent_money
  
  for i = 0, users_count - 1 do
    local user_node  = users_node:Child (i)
    local user_id    = GetNodeChildAttribute (user_node, "userId") + 0
    local user_money = GetNodeChildAttribute (user_node, "money", 0) + 0
    
    if user_id == GetUserId () then
      impl.battle_user_new_money = user_money
    else
      new_opponent_money = user_money
    end
  end

  impl.new_opponent_money = new_opponent_money
  
  if new_opponent_money ~= impl.last_battle_opponent_money then
    table.insert (impl.battle_info_opponent_update_actions, DelayedAction ("ui", BATTLE_OPPONENT_UPDATE_DELAY, function ()
      impl.battle_opponent_money = new_opponent_money
    
      UpdateBattleInfoOverlay (impl)
    end))
  end
end

local function OnBattleInterrupt (impl) 
  if not impl.battle_active then return end
  
  game.scripts.top_ui.SetBackToLobbyButtonState (true)
  
  game.scripts.ui_windows.ShowAlertWindow (nil, nil, function ()
      SetCurrentScreen ("lobby")
    end, nil, { GetLocalizedString ("BATTLE.OPPONENT_LEAVE_ALERT") })
end

local function OnBattleStart (impl)
  impl.battle_start_time = game.main_timer.GetTime () + 3

  DelayedAction (game.main_timer, 0.1, function ()
    game.scripts.ui_windows.ShowBattleStartCounter (function ()
      game.scripts.top_ui.SetBackToLobbyButtonState (true)
  
      SetUiState (impl, true)

      if impl.timer_animation then
        impl.timer_animation.Show ("animate", function ()
          impl.timer_animation.Hide ()
        end)
      end
      
      impl.battle_started = true
    end)
  end)
  
  ExecuteOnNextUpdate (function ()
    UpdateBalanceText (impl)
  end)
end

local function OnBattleResult (impl, status, money, rating, interrupted)
  impl.battle_result = { status = status, money = money, interrupted = interrupted, rating = rating }
 
  if impl.spin_started then return end
 
  ShowBattleResult (impl)
end

local function OnBattleInvite (impl, invite_data) 
  if not impl.battle_active then return end  --ignore battle invites in single_player mode
  if not impl.battle_result then return end  --ignore battle invites if battle is in progress
  
  game.scripts.ui_windows.ShowBattleInviteWindow (invite_data.mode_id, invite_data.opponent)
end

local function OnAchievementComplete (impl, achievement_data)
  if impl.battle_result then return end --ignore achivements received after battle result shown

  table.insert (impl.achievement_complete_queue, { data = achievement_data, group = false })
  
  if impl.spin_started then return true end

  ShowQueuedAchievements (impl)  
  
  return true
end

local function OnAchievementGroupComplete (impl, achievement_data)
  if impl.battle_result then return end --ignore achivements received after battle result shown

  table.insert (impl.achievement_complete_queue, { data = achievement_data, group = true })
  
  if impl.spin_started then return true end

  ShowQueuedAchievements (impl)  
  
  return true
end

local_methods.ShowQueuedTopNotifications = function (impl)
  for i = 1, #impl.top_notifications_queue do
    local info = impl.top_notifications_queue [i]
  
    if impl.battle_active then
      local icon
    
      if info.place == 1 then
        icon = "battle_info_window_top_1"
      elseif info.place == 2 then
        icon = "battle_info_window_top_2"
      elseif info.place == 3 then
        icon = "battle_info_window_top_3"
      elseif info.place < 11 then
        icon = "battle_info_window_top_10"
      else
        icon = "battle_info_window_top_100"
      end
    
      local replacements = {
        { token = "{place}",  replacement = tostring (info.place) },
        { token = "{rating_name}",  replacement = GetLocalizedString ("WINNER_OF_BEST_PLAYER.RATING_NAME_" .. info.top_type) }
      }

      local type

      if info.place < 4 then
        type = 1
      elseif info.place < 11 then
        type = 2
      else
        type = 3
      end

      local info_texts = {}

      for i = 1, 3 do
        table.insert (info_texts, ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.TOP_LINE_" .. i .. "_" .. type), replacements))
      end

      game.scripts.ui_windows.ShowBattleInfoWindow (icon, GetLocalizedString ("BATTLE_INFO_WINDOW.TOP_TITLE_" .. type), info_texts)
    else
      game.scripts.ui_windows.ShowTopNotificationWindow (info)
    end
  end
  
  impl.top_notifications_queue = {}
end

local_methods.OnTopNotification = function (impl, info)
  if impl.battle_result then return end --ignore notifications received after battle result shown

  local dont_show_later = info.top_type ~= 1

  table.insert (impl.top_notifications_queue, info)
  
  if impl.spin_started then return dont_show_later end

  local_methods.ShowQueuedTopNotifications (impl)  
  
  return dont_show_later
end

local_methods.ShowPendingPrizesInBattle = function (impl, override_prizes) 
  if not impl.battle_active then return end
  if impl.battle_result then return end
  
  local pending_prizes = override_prizes or GetPrizes ()

  for i = 1, #pending_prizes do
    local prize = pending_prizes [i]  

    if not impl.shown_prizes [prize.id] then
      impl.shown_prizes [prize.id] = true
    
      if not prize.shown and not prize.shown_in_battle and prize.place > 0 and prize.place < 4 and
          prize.type >= 0 and prize.type < 3 then
        prize.shown_in_battle = true

        local replacements = {
          { token = "{place}",  replacement = tostring (prize.place) },
          { token = "{rating_name}",  replacement = GetLocalizedString ("WINNER_OF_BEST_PLAYER.RATING_NAME_" .. prize.type) }
        }

        local info_texts = {}

        for i = 1, 3 do
          table.insert (info_texts, ProcessStringWithReplacements (GetLocalizedString ("BATTLE_INFO_WINDOW.PRIZE_LINE_" .. i), replacements))
        end

        game.scripts.ui_windows.ShowBattleInfoWindow ("battle_info_window_prize_" .. prize.place, GetLocalizedString ("BATTLE_INFO_WINDOW.PRIZE_TITLE"), info_texts)
      end
    end
  end
end

local function ForceActivateTurbo (impl) 
  impl.turbo_force_activated = true
end

local_methods.SetPlayButtonHidden = function (impl, state) 
  impl.play_button_hidden = state
  
  if state then
    SetSpritesActive (false, impl.play_button_disabled, impl.play_button_enabled)

    if not impl.phone_ui then
      SetTextLineActive (impl.play_active_text, false)
      SetTextLineActive (impl.play_passive_text, false)
    end
  else
    SetSpritesActive (not impl.ui_state, impl.play_button_disabled)
    SetSpritesActive (impl.ui_state, impl.play_button_enabled)

    if not impl.phone_ui then
      SetTextLineActive (impl.play_active_text, impl.ui_state)
      SetTextLineActive (impl.play_passive_text, not impl.ui_state)
    end
  end
end

local function GetReelCenterX (impl, reel_index)
  return impl.reels [reel_index].start_position.x
end

local function GetLineCenterY (impl, line_index) 
  return impl.reels [1].start_position.y - impl.line_interval * (line_index - 1)
end

local function GetSlotsCenter (impl) 
  return { x = impl.reel_clip_zone.left + impl.reel_clip_zone.width / 2, y = impl.reel_clip_zone.top - impl.reel_clip_zone.height / 2 }
end

local function AddLongPressHandler (impl, sprite, name, handler)
  local action = {}

  impl.long_press_actions [name] = action

  AttachInputZone (sprite, Scene.InputZoneNotification.OnPress, function (viewport, notification, context)
    action.fire_action = DelayedAction ("default", LONG_PRESS_DURATION, function ()
      handler ()
    end)
  end)
    
  AttachInputZone (sprite, Scene.InputZoneNotification.OnClick, function (viewport, notification, context)
    if action.fire_action then
      action.fire_action.Stop ()
      action.fire_action = nil
    end
  end)
end

local function LoadLevel (impl, xml_desc)
  impl.last_win_value = 0

    --camera properties
  impl.camera = game.current_screen.cameras ["slots_camera"].node
  
  local min_camera_zone = GetSprite (xml_desc:Get ("MinCameraZone"))
  
  min_camera_zone = min_camera_zone.layout
  
  impl.min_camera_width    = min_camera_zone:Get ("Width")  + 0
  impl.min_camera_height   = min_camera_zone:Get ("Height") + 0
  impl.min_camera_center_x = min_camera_zone:Get ("Left") + impl.min_camera_width / 2
  impl.min_camera_center_y = -min_camera_zone:Get ("Top") - impl.min_camera_height / 2

  impl.min_ar = impl.min_camera_width / impl.min_camera_height

    --slots properties
  impl.free_spins_label_shown = false
  
  impl.phone_ui = game.current_screen.vars.phone_ui or 0 ~= 0

  impl.achievement_complete_queue = {}
  impl.top_notifications_queue    = {}
  impl.win_lines                  = {}
  impl.long_press_actions         = {}
  
  impl.mega_lines_show_sprites    = SplitString (xml_desc:Get ("MegaLinesShowSprites", ""), " ", true)
  impl.mega_lines_show_text_lines = SplitString (xml_desc:Get ("MegaLinesShowTextLines", ""), " ", true)
  impl.mega_lines_hide_sprites    = SplitString (xml_desc:Get ("MegaLinesHideSprites", ""), " ", true)
  impl.mega_lines_hide_text_lines = SplitString (xml_desc:Get ("MegaLinesHideTextLines", ""), " ", true)

  local ui_node
  
  if impl.phone_ui then
    ui_node = xml_desc:Find ("PhoneUI")
    
    impl.total_bet_max_symbols_count = game.current_screen.vars.total_bet_max_symbols_count or PHONE_TOTAL_BET_MAX_SYMBOLS_COUNT
    impl.payout_max_symbols_count    = game.current_screen.vars.payout_max_symbols_count or PHONE_PAYOUT_MAX_SYMBOLS_COUNT
    impl.payment_table_line_active   = { "paytable_button" }
    impl.payment_table_line_passive  = { "paytable_button_d" }
  else
    ui_node = xml_desc:Find ("PadUI")
    
    impl.total_bet_max_symbols_count = game.current_screen.vars.total_bet_max_symbols_count or PAD_TOTAL_BET_MAX_SYMBOLS_COUNT
    impl.payout_max_symbols_count    = game.current_screen.vars.payout_max_symbols_count or PAD_PAYOUT_MAX_SYMBOLS_COUNT
    
    impl.play_active_text          = GetTextLine (ui_node:Get ("PlayButton.TextEnabled"))
    impl.play_passive_text         = GetTextLine (ui_node:Get ("PlayButton.TextDisabled"))  
    
    impl.all_lines_active_text    = SplitString (ui_node:Get ("AllLinesButton.TextEnabled"), " ", true)
    impl.all_lines_passive_text   = SplitString (ui_node:Get ("AllLinesButton.TextDisabled")  , " ", true)
    impl.payment_table_line_active  = SplitString (ui_node:Get ("PaymentTableButton.TextEnabled"), " ", true)
    impl.payment_table_line_passive = SplitString (ui_node:Get ("PaymentTableButton.TextDisabled"), " ", true)
  end
  
  local free_spins_spinning_directions = SplitString (xml_desc:Get ("FreeSpinsSpinningDirections", "true true true true true"), " ", true)

  if #free_spins_spinning_directions == 5 then
    for i = 1, #free_spins_spinning_directions do
      free_spins_spinning_directions [i] = free_spins_spinning_directions [i] == "true"
    end
  
    impl.free_spins_spinning_directions = free_spins_spinning_directions
  end

  impl.win_sound                  = xml_desc:Get ("WinSound")
  impl.free_spins_end_sound       = xml_desc:Get ("FreeSpinsEndSound")
  impl.free_spins_spinning_sounds = SplitString (xml_desc:Get ("FreeSpinsSpinningSound"), " ", true)
  impl.spinning_sounds            = SplitString (xml_desc:Get ("SpinningSound"), " ", true)
  impl.swipe_sound_enabled        = xml_desc:Get ("SwipeSoundEnabled", "true") == "true"

  local spin_start_sound = xml_desc:Get ("SpinStartSound", "")

  if spin_start_sound ~= "" then
    impl.spin_start_sound = spin_start_sound
  end

  local wild_stop_sound = xml_desc:Get ("WildStopSound", "")
  
  if wild_stop_sound ~= "" then
    impl.wild_stop_sound = wild_stop_sound
  end

  local double_wild_stop_sound = xml_desc:Get ("DoubleWildStopSound", "")
  
  if double_wild_stop_sound ~= "" then
    impl.double_wild_stop_sound = double_wild_stop_sound
  end
  
  local bonus_yes_sound = xml_desc:Get ("BonusYesSound", "")
  
  if bonus_yes_sound ~= "" then
    impl.bonus_yes_sound          = bonus_yes_sound
    impl.bonus_yes_sound_duration = xml_desc:Get ("BonusYesSoundDuration", "0") + 0
  end

  local bonus_no_sound = xml_desc:Get ("BonusNoSound", "")
  
  if bonus_no_sound ~= "" then
    impl.bonus_no_sound          = bonus_no_sound
    impl.bonus_no_sound_duration = xml_desc:Get ("BonusNoSoundDuration", "0") + 0
  end

  impl.current_spinning_sound            = 0
  impl.current_free_spins_spinning_sound = 0

  impl.scatter_line_material = xml_desc:Get ("ScatterLineMaterial")
  impl.scatter_line_color    = GetColor  (xml_desc:Get ("ScatterLineColor"))

  impl.play_button_enabled             = GetSprite (ui_node:Get ("PlayButton.Enabled"))
  impl.play_button_disabled            = GetSprite (ui_node:Get ("PlayButton.Disabled"))
  impl.all_lines_button_enabled        = GetSprite (ui_node:Get ("AllLinesButton.Enabled"))
  impl.all_lines_button_disabled       = GetSprite (ui_node:Get ("AllLinesButton.Disabled"))
  impl.bet_more_button_enabled         = GetSprite (ui_node:Get ("BetMoreButton.Enabled"))
  impl.bet_more_button_disabled        = GetSprite (ui_node:Get ("BetMoreButton.Disabled"))
  impl.lines_more_button_enabled       = GetSprite (ui_node:Get ("LinesMoreButton.Enabled"))
  impl.lines_more_button_disabled      = GetSprite (ui_node:Get ("LinesMoreButton.Disabled"))
  impl.payment_table_button_enabled    = GetSprite (ui_node:Get ("PaymentTableButton.Enabled"))
  impl.payment_table_button_disabled   = GetSprite (ui_node:Get ("PaymentTableButton.Disabled"))
  impl.lines_text_line                 = GetTextLine (xml_desc:Get ("LinesTextLine"))
  impl.bet_text_line                   = GetTextLine (xml_desc:Get ("BetTextLine"))
  impl.total_bet_text_line             = GetTextLine (xml_desc:Get ("TotalBetTextLine"))
  impl.win_text_line                   = GetTextLine (xml_desc:Get ("WinTextLine"))
  impl.slot_id                         = GetProfileProperty ("CurrentSlotId") + 0
  impl.free_spins_win_count_text_line  = GetTextLine (xml_desc:Get ("FreeSpinsWinCountTextLine"))
  impl.free_spins_win_payout_text_line = GetTextLine (xml_desc:Get ("FreeSpinsWinPayoutTextLine"))
  impl.free_spins_auto_play_delay      = xml_desc:Get ("FreeSpinsAutoPlayDelay") + 0

  local slots = GetSlots ()

  for i = 1, #slots do
    local slot_desc = slots [i]

    if slot_desc.id == impl.slot_id then
      impl.lines_count = slot_desc.lines
      break
    end
  end

  AddLongPressHandler (impl, impl.bet_more_button_enabled, "bet_more", function ()
    PlaySound ("slots_click")
  
    local max_bet_index = local_methods.GetMaxBetIndex (impl)
  
    impl.bet = GetBets () [max_bet_index - 1]

    BetMore (impl)

    impl.next_bet_more_disabled = true
  end)
  
  AddLongPressHandler (impl, impl.lines_more_button_enabled, "lines_more", function ()
    PlaySound ("slots_click")
  
    impl.active_lines = impl.lines_count
  
    ActivateLines (impl, impl.active_lines, true)

    impl.next_lines_more_disabled = true
  end)
  
  local free_spins_payout_max_digits_count = ui_node:Get ("FreeSpinsPayoutMaxDigitsCount", "") 

  if free_spins_payout_max_digits_count ~= "" then
    impl.free_spins_payout_max_digits_count = free_spins_payout_max_digits_count + 0
  end 

  impl.bonus_screen = game.current_screen.name .. BONUS_SCREEN_NAME_SUFFIX

  local free_spins_count_text_line = xml_desc:Get ("FreeSpinsCountTextLine", "")
  
  if free_spins_count_text_line ~= "" then
    impl.free_spins_count_text_line = GetTextLine (free_spins_count_text_line)
  end

  impl.free_spins_results_sprites = SplitString (xml_desc:Get ("FreeSpinsResultsSprites"), " ", true)
  impl.free_spins_loose_sprites   = SplitString (xml_desc:Get ("FreeSpinsLooseSprites"), " ", true)
  impl.free_spins_win_sprites     = SplitString (xml_desc:Get ("FreeSpinsWinSprites"), " ", true)

  impl.free_spins_loose_text_lines = SplitString (xml_desc:Get ("FreeSpinsLooseTextLines"), " ", true)
  impl.free_spins_win_text_lines   = SplitString (xml_desc:Get ("FreeSpinsWinTextLines"), " ", true)
  
  local bonus_paytable_lines_node = ui_node:Find ("BonusPayTableLines") 

  if bonus_paytable_lines_node then
    impl.bonus_paytable_from_5_text_line = GetTextLine (bonus_paytable_lines_node:Get ("From5"))
    impl.bonus_paytable_to_5_text_line   = GetTextLine (bonus_paytable_lines_node:Get ("To5"))
    impl.bonus_paytable_from_4_text_line = GetTextLine (bonus_paytable_lines_node:Get ("From4"))
    impl.bonus_paytable_to_4_text_line   = GetTextLine (bonus_paytable_lines_node:Get ("To4"))
    impl.bonus_paytable_from_3_text_line = GetTextLine (bonus_paytable_lines_node:Get ("From3"))
    impl.bonus_paytable_to_3_text_line   = GetTextLine (bonus_paytable_lines_node:Get ("To3"))
  end

  impl.symbols_paytable_lines = {}
  
  local symbols_paytable_lines_node = ui_node:Find ("SymbolsPayTableLines")
  local symbols_count               = symbols_paytable_lines_node.ChildrenCount
  
  for i = 0, symbols_count - 1 do
    local symbol_node = symbols_paytable_lines_node:Child (i)
    
    if symbol_node.Name == "Symbol" then
      local symbol      = {}
      local lines_count = symbol_node.ChildrenCount
      
      for j = 0, lines_count - 1 do
        local line_node = symbol_node:Child (j)
        
        if line_node.Name == "Line" then
          symbol [line_node:Get ("Count") + 0] =  GetTextLine (line_node:Get ("Name"))
        end
      end
      
      table.insert (impl.symbols_paytable_lines, symbol)
    end
  end

  if not impl.phone_ui then
    impl.balance_text_line          = GetTextLine (xml_desc:Get ("BalanceTextLine"))
    impl.bet_less_button_enabled    = GetSprite (ui_node:Get ("BetLessButton.Enabled"))
    impl.bet_less_button_disabled   = GetSprite (ui_node:Get ("BetLessButton.Disabled"))
    impl.lines_less_button_enabled  = GetSprite (ui_node:Get ("LinesLessButton.Enabled"))
    impl.lines_less_button_disabled = GetSprite (ui_node:Get ("LinesLessButton.Disabled"))

    AddLongPressHandler (impl, impl.bet_less_button_enabled, "bet_less", function ()
      PlaySound ("slots_click")

      impl.bet = GetBets () [2]

      BetLess (impl)
      
      impl.next_bet_less_disabled = true
    end)
  
    AddLongPressHandler (impl, impl.lines_less_button_enabled, "lines_less", function ()
      PlaySound ("slots_click")

      impl.active_lines = 1

      ActivateLines (impl, impl.active_lines, true)

      impl.next_lines_less_disabled = true
    end)
  
    impl.max_balance_symbols = ui_node:Get ("MaxBalanceSymbols") + 0
    
    local win_table_node = ui_node:Find ("WinTable")
    
    if win_table_node then
      local footer_sprite = win_table_node:Get ("FooterSprite", "")
      
      if footer_sprite ~= "" then
        impl.win_table_footer = GetSprite (footer_sprite)
      end
    
      impl.win_table_open_click_sound = win_table_node:Get ("OpenClickSound", "slots_click")
      impl.win_table_line_click_sound = win_table_node:Get ("LineClickSound", "slots_click")
      impl.win_table_z                = GetSprite (win_table_node:Get ("AfterSprite")).z
      impl.win_table_header           = GetSprite (win_table_node:Get ("HeaderSprite"))
      impl.win_close_button           = GetSprite (win_table_node:Get ("CloseButtonSprite"))
      impl.win_open_button            = GetSprite (win_table_node:Get ("OpenButtonSprite"))
      impl.win_line                   = GetSprite (win_table_node:Get ("LineSprite"))
      impl.win_line_selected          = GetSprite (win_table_node:Get ("SelectedLineSprite"))
      impl.win_line_sprite_offset_y   = win_table_node:Get ("LineSpriteOffsetY", "0") + 0
      impl.win_table_open_duration    = win_table_node:Get ("OpenDuration") + 0
      impl.win_table_offset_y         = win_table_node:Get ("OffsetY", "0") + 0
      impl.win_table_scissor_offset   = win_table_node:Get ("ScissorOffset", "0") + 0
      impl.win_line_header_offset_y   = win_table_node:Get ("HeaderOffsetY", "0") + 0
      impl.win_line_header_offset_x   = win_table_node:Get ("HeaderOffsetX", "0") + 0
      impl.win_line_footer_offset_y   = win_table_node:Get ("FooterOffsetY", "0") + 0
      
      impl.win_lines_text_offset_x       = win_table_node:Get ("LinesTextOffsetX") + 0
      impl.win_win_text_offset_x         = win_table_node:Get ("WinTextOffsetX") + 0
      impl.win_lines_title_text_offset_y = win_table_node:Get ("LinesTitleTextOffsetY") + 0
      impl.win_win_title_text_offset_y   = win_table_node:Get ("WinTitleTextOffsetY") + 0
      impl.win_lines_value_text_offset_y = win_table_node:Get ("LinesValueTextOffsetY") + 0
      impl.win_win_value_text_offset_y   = win_table_node:Get ("WinValueTextOffsetY") + 0
      impl.win_lines_title_color         = GetColor (win_table_node:Get ("LinesTitleColor"))
      impl.win_lines_title_size          = win_table_node:Get ("LinesTitleSize") + 0
      impl.win_lines_title_stroke_color  = GetColorOrNil (win_table_node:Get ("LinesTitleStrokeColor", ""))
      impl.win_win_title_color           = GetColor (win_table_node:Get ("WinTitleColor"))
      impl.win_win_title_size            = win_table_node:Get ("WinTitleSize") + 0
      impl.win_win_title_stroke_color    = GetColorOrNil (win_table_node:Get ("WinTitleStrokeColor", ""))
      impl.win_lines_value_color         = GetColor (win_table_node:Get ("LinesValueColor"))
      impl.win_lines_value_size          = win_table_node:Get ("LinesValueSize") + 0
      impl.win_lines_value_stroke_color  = GetColorOrNil (win_table_node:Get ("LinesValueStrokeColor", ""))
      impl.win_win_value_color           = GetColor (win_table_node:Get ("WinValueColor"))
      impl.win_win_value_size            = win_table_node:Get ("WinValueSize") + 0
      impl.win_win_value_stroke_color    = GetColorOrNil (win_table_node:Get ("WinValueStrokeColor", ""))      
    
      local clip_bottom = -impl.win_close_button.layout:Get ("Top") - impl.win_table_scissor_offset

      impl.win_table_scissor = CreateScissor (0, 0, impl.camera.Right, -clip_bottom)

      impl.win_table_scissor:BindToScene (impl.camera.Scene)
    end
  end

  impl.paytable_pages = {}
  
  local paytable_pages_node = ui_node:Find ("PaytablePages")
  local pages_count         = paytable_pages_node.ChildrenCount
  
  for i = 0, pages_count - 1 do
    local page_node = paytable_pages_node:Child (i) 

    if page_node.Name == "Page" then
      local page = {}
      
      page.sprites    = {}
      page.text_lines = {}

      local children_count = page_node.ChildrenCount
      
      for j = 0, children_count - 1 do
        local child = page_node:Child (j)
        
        if child.Name == "Sprite" then
          table.insert (page.sprites, GetSprite (child:Get ("Name")))
        elseif child.Name == "TextLine" then
          table.insert (page.text_lines, child:Get ("Name"))
        else
          error ("Unknown node " .. child.Name .. " in paytable page")
        end
      end
      
      table.insert (impl.paytable_pages, page)
    else
      error ("Unknown node " .. page_node.Name .. " in paytable pages")
    end
  end
  
  impl.items = {}
  impl.items_list = {}

  local items_node           = xml_desc:Find ("Items")
  local items_children_count = items_node.ChildrenCount
  
  for i = 0, items_children_count - 1 do
    local item_node = items_node:Child (i)
    
    if item_node.Name == "Item" then
      local item = {}

      local function SetupItemFromSprites (item_node, item, sprite, blurred_sprite, node_name_prefix)
        local sprite         = GetSprite (sprite)
        local blurred_sprite = GetSprite (blurred_sprite)

        ActivateSprites (sprite, blurred_sprite)

        item.material          = sprite.node.Material
        item.scale             = sprite.node.WorldScale
        item.tex_size          = StringToVec (sprite.layout:Get ("TexSize"))
        item.tex_offset        = StringToVec (sprite.layout:Get ("TexOffset"))
        item.blured_material   = blurred_sprite.node.Material
        item.blured_scale      = blurred_sprite.node.WorldScale
        item.blured_tex_size   = StringToVec (blurred_sprite.layout:Get ("TexSize"))
        item.blured_tex_offset = StringToVec (blurred_sprite.layout:Get ("TexOffset"))
        item.sound             = item_node:Get (node_name_prefix .. "Sound", "")

        DeactivateSprites (sprite, blurred_sprite)

        local animation_format = item_node:Get (node_name_prefix .. "AnimationFormat", "")
    
        if animation_format == "" then
          item.animation = nil
        else
          local first_frame = item_node:Get (node_name_prefix .. "AnimationFirstFrame") + 0 
          local last_frame  = item_node:Get (node_name_prefix .. "AnimationLastFrame") + 0
          local frames      = {}

          for i = first_frame, last_frame do
            table.insert (frames, string.format (animation_format, i))
          end      

          item.animation = CreateAnimationSpriteClass ({ stay = { frames [1] }, animate = frames }, frames [1], item_node:Get (node_name_prefix .. "AnimationFps") + 0)
        end
      end
      
      SetupItemFromSprites (item_node, item, item_node:Get ("Sprite"), item_node:Get ("BluredSprite"), "")

      item.index       = i      
      item.wide        = item_node:Get ("Wide", "") == "true"
      item.wild        = item_node:Get ("Wild", "") == "true"
      item.double_wild = item_node:Get ("DoubleWild", "") == "true"
      item.bonus_spin  = item_node:Get ("BonusSpin", "") == "true"

      local stop_sound = item_node:Get ("StopSound", "")
      
      if stop_sound ~= "" then
        item.stop_sound = stop_sound
      end

      local highlighted_sprite = item_node:Get ("HighlightedSprite", "")

      if highlighted_sprite ~= "" then
        local ref_sprite = GetSprite (highlighted_sprite)
      
        item.highlighted_material   = ref_sprite.node.Material
        item.highlighted_tex_size   = StringToVec (ref_sprite.layout:Get ("TexSize"))
        item.highlighted_tex_offset = StringToVec (ref_sprite.layout:Get ("TexOffset"))
      end

      local item_id = item_node:Get ("Id")
      
      impl.items [item_id] = item
      
      table.insert (impl.items_list, item_id)
    end
  end
  
  local line_1_pivot       = GetSprite (xml_desc:Get ("Line1Pivot"))
  local line_2_pivot       = GetSprite (xml_desc:Get ("Line2Pivot"))
  local reels_after_sprite = GetSprite (xml_desc:Get ("ReelsAfterSprite"))
  
  ActivateSprites (line_1_pivot, line_2_pivot)
  
  impl.line_interval = line_1_pivot.position.y - line_2_pivot.position.y

  impl.reels = {}

  for i = 1, 5 do
    local reel = {}

    local reel_pivot = GetSprite (xml_desc:Get ("Reel" .. i .. "Pivot"))
  
    ActivateSprite (reel_pivot)
  
    reel.start_position = vec3 (reel_pivot.position.x, line_2_pivot.position.y + impl.line_interval, reels_after_sprite.z - EPS)
    
    DeactivateSprite (reel_pivot)
  
    reel.node = Scene.Node.Create ()
    reel.node:BindToParent (game.current_screen.node)
    reel.node.Position = reel.start_position
  
    reel.stop_node = Scene.Node.Create ()
    
    table.insert (impl.reels, reel)
  end
  
  impl.spin_engine.Setup (impl.reels, impl.line_interval, xml_desc, 3)

  DeactivateSprites (line_1_pivot, line_2_pivot)
  
  local reels_clip_zone_sprite

  local reels_clip_zone_full = xml_desc:Get ("ReelsClipZoneFull", "")
  
  if reels_clip_zone_full ~= "" then
    reels_clip_zone_sprite = GetSprite (reels_clip_zone_full, true) 
  end
  
  if not reels_clip_zone_sprite then
    reels_clip_zone_sprite = GetSprite (xml_desc:Get ("ReelsClipZone"))
  end
  
  local reels_clip_zone_layout = reels_clip_zone_sprite.layout
  
  impl.reel_clip_zone = {}
  
  impl.reel_clip_zone.left   = reels_clip_zone_layout:Get ("Left") + 0
  impl.reel_clip_zone.top    = -reels_clip_zone_layout:Get ("Top")
  impl.reel_clip_zone.width  = reels_clip_zone_layout:Get ("Width") + 0
  impl.reel_clip_zone.height = reels_clip_zone_layout:Get ("Height") + 0
  
  impl.lines = {}
  
  local lines_node           = xml_desc:Find ("Lines")
  local lines_children_count = lines_node.ChildrenCount
  
  impl.lines_z = GetSprite (lines_node:Get ("AfterSprite")).z
  
  local lines_z = impl.lines_z
  
  for i = 0, lines_children_count - 1 do
    local line_node = lines_node:Child (i)
    
    if line_node.Name == "Line" then
      local line = {}
      
      local left_enabled_name   = line_node:Get ("EnabledLeft", "")
      local right_enabled_name  = line_node:Get ("EnabledRight", "")
      local left_disabled_name  = line_node:Get ("DisabledLeft", "")
      local right_disabled_name = line_node:Get ("DisabledRight", "")
      
      if left_enabled_name ~= "" then
        line.left_enabled = GetSprite (left_enabled_name)
      end
      if right_enabled_name ~= "" then
        line.right_enabled = GetSprite (right_enabled_name)
      end
      if left_disabled_name ~= "" then
        line.left_disabled = GetSprite (left_disabled_name)
      end
      if right_disabled_name ~= "" then
        line.right_disabled = GetSprite (right_disabled_name)
      end
      
      line.line_sprites = {}

      line.material = line_node:Get ("Material")
      line.color    = GetColor (line_node:Get ("Color"))      
      line.points   = {}

      local width        = game.current_screen.vars.line_width
      local points_node  = line_node:Find ("Points")
      local points_count = points_node.ChildrenCount
      local prev_point

      for j = 0, points_count - 1 do
        local point_node = points_node:Child (j)
        
        if point_node.Name == "Point" then
          local current_point = {}
          
          local sprite = point_node:Get ("Sprite", "")
          
          if sprite ~= "" then
            local layout          = GetSprite (sprite).layout
          
            current_point = {}
            
            current_point.x = layout:Get ("Left") + layout:Get ("Width") / 2
            current_point.y = -layout:Get ("Top") - layout:Get ("Height") / 2
            
            local reel = point_node:Get ("Reel", "")
            
            if reel ~= "" then
              current_point.x = impl.reels [reel + 0].start_position.x
            end
          else
            current_point = GetCellPosition (impl, point_node:Get ("Line") + 0, point_node:Get ("Reel") + 0)
          end

          local specific_offset = game.current_screen.vars [string.format ("line_" .. #impl.lines .. "_" .. #line.line_sprites .. "_offset")] or 0

          current_point = vec3 (current_point.x, current_point.y + point_node:Get ("Offset", "0") * impl.line_interval + specific_offset * impl.line_interval, 0)

          local horizontal = point_node:Get ("Horizontal", "0") ~= "0"

          if prev_point then
            if horizontal then
              current_point.y = prev_point.y
            end

            local line_sprite = CreateLineSprite (line.material, line.color, width, prev_point, current_point, lines_z)
            
            table.insert (line.line_sprites, line_sprite)

            lines_z = lines_z - EPS
          end

          table.insert (line.points, current_point)
          
          prev_point = current_point
        end
      end
      
      table.insert (impl.lines, line)
    end
  end

  impl.active_lines = impl.lines_count

  impl.balance = math.max (0, GetUserMoney ())

  UpdateBalanceText (impl)
  
  game.scripts.top_ui.SetMoneyAutoUpdate (false)
  
  impl.animations_z = lines_z - EPS
  
  impl.win_animations_node = Scene.Node.Create ()
  
  impl.win_animations_node:BindToParent (game.current_screen.node)
end

local_methods.OnLostScreen = function (impl)
  if impl.overrided_on_lost_screen then
    impl.overrided_on_lost_screen ()
  end
end

function CreateLevelTemplateSlots (xml_desc, event_handler)
  local impl = {}  

  impl.battle_active = ApplicationDataGet (IS_BATTLE_ACTIVE)

  impl.spin_engine = CreateSpinEngine (function ()
    OnSpinFinished (impl)
  end, impl)

  impl.event_handler = event_handler
   
  LoadLevel (impl, xml_desc)

  local window        = Engine.Windows.Find (WINDOW_NAME)
  local window_width  = window.ClientWidth
  local window_height = window.ClientHeight

  impl.AnimateAllWinLines  = function () AnimateAllWinLines (impl) end
  impl.OnReelSpinStopped   = function (reel_index) OnReelSpinStopped (impl, reel_index) end
  impl.OnReelStopInitiated = function (reel_index) OnReelStopInitiated (impl, reel_index) end
  
  local public_methods = {}

  public_methods.ActivateDoubleBet          = function () ActivateDoubleBet (impl) end
  public_methods.ActivateLines              = function (count, sound_name) if impl.ui_state then ActivateLines (impl, count, true, sound_name) end end
  public_methods.AddFreeSpinsWithAnimation  = function (add_value) AddFreeSpinsWithAnimation (impl, add_value) end
  public_methods.AllLinesPlay               = function () AllLinesPlay (impl) end
  public_methods.BetLess                    = function () BetLess (impl) end
  public_methods.BetMore                    = function () BetMore (impl) end
  public_methods.ClearWinLines              = function () ClearWinLines (impl) end
  public_methods.ForceActivateTurbo         = function () ForceActivateTurbo (impl) end
  public_methods.GetActiveBetIndex          = function () return local_methods.GetCurrentBetIndex (impl) end
  public_methods.GetActiveLinesCount        = function () return impl.active_lines end
  public_methods.GetBet                     = function () return impl.bet.money end
  public_methods.GetBonusMaxWin             = function () return impl.bonus_max_win end
  public_methods.GetBonusSpinSymbolSprite   = function () return local_methods.GetBonusSpinSymbolSprite (impl) end
  public_methods.GetCamera                  = function () return impl.camera end
  public_methods.GetPayTable                = function () return impl.paytable end
  public_methods.GetPlayButtonSprite        = function () return impl.play_button_enabled end
  public_methods.GetReelCenterX             = function (reel_index) return GetReelCenterX (impl, reel_index) end
  public_methods.GetLineCenterY             = function (line_index) return GetLineCenterY (impl, line_index) end
  public_methods.GetSlotsCenter             = function () return GetSlotsCenter (impl) end
  public_methods.GetTotalBet                = function () return impl.bet.money * impl.active_lines end
  public_methods.GetTotalBetTextLine        = function () return impl.total_bet_text_line end
  public_methods.HasSpinStartSound          = function () return impl.spin_start_sound ~= nil end 
  public_methods.HideFreeSpinsResults       = function () HideFreeSpinsResults (impl) end
  public_methods.IsAllLines                 = function () return impl.active_lines >= impl.lines_count end
  public_methods.IsMaxBet                   = function () return local_methods.GetCurrentBetIndex (impl) == local_methods.GetMaxBetIndex (impl) end
  public_methods.LinesLess                  = function () LinesLess (impl) end
  public_methods.LinesMore                  = function () LinesMore (impl) end
  public_methods.OnAchievementComplete      = function (achievement_data) return OnAchievementComplete (impl, achievement_data) end
  public_methods.OnAchievementGroupComplete = function (achievement_data) return OnAchievementGroupComplete (impl, achievement_data) end
  public_methods.OnBattleInfoUpdated        = function (event) OnBattleInfoUpdated (impl, event) end
  public_methods.OnBattleInterrupt          = function () OnBattleInterrupt (impl) end
  public_methods.OnBattleInvite             = function (invite_data) OnBattleInvite (impl, invite_data) end
  public_methods.OnBattleResult             = function (status, money, rating, interrupted) OnBattleResult (impl, status, money, rating, interrupted) end
  public_methods.OnBattleStart              = function () OnBattleStart (impl) end
  public_methods.OnDoubleWindowClosed       = function () OnDoubleWindowClosed (impl) end
  public_methods.OnDragSlots                = function (touch, y) OnDragSlots (impl, touch, y) end
  public_methods.OnDragSlotsEnded           = function (touch) OnDragSlotsEnded (impl, touch) end
  public_methods.OnDragSlotsStarted         = function (touch, y) OnDragSlotsStarted (impl, touch, y) end
  public_methods.OnFreeSpinsGain            = function (event) OnFreeSpinsGain (impl, event) end
  public_methods.OnGiftsSent                = function () OnGiftsSent (impl) end
  public_methods.OnLostScreen               = function () local_methods.OnLostScreen (impl) end
  public_methods.OnSizeChanged              = function (window_width, window_height) OnSizeChanged (impl, window_width, window_height) end
  public_methods.OnSlotSpinResponse         = function (event) OnSlotSpinResponse (impl, event) end
  public_methods.OnTopNotification          = function (info) return local_methods.OnTopNotification (impl, info) end
  public_methods.OnUserLevelUp              = function () return OnUserLevelUp (impl) end
  public_methods.OnUnsupportedEventReceived = function () end
  public_methods.OpenWinTable               = function (state) OpenWinTable (impl, state, nil, true) end
  public_methods.PaymentTable               = function () PaymentTable (impl) end
  public_methods.PaymentTableForward        = function () PaymentTableForward (impl) end
  public_methods.PaymentTableBack           = function () PaymentTableBack (impl) end
  public_methods.Play                       = function (hold_reels, no_spin_start_sound, params) Play (impl, hold_reels, no_spin_start_sound, params) end
  public_methods.ResetAutoSpins             = function () local_methods.ResetAutoSpins (impl) end
  public_methods.ResumeFreeSpins            = function () local_methods.ResumeFreeSpins (impl) end
  public_methods.SetAutoSpinPaused          = function (state, no_spin) local_methods.SetAutoSpinPaused (impl, state, no_spin) end
  public_methods.SetHasMoreAutoSpins        = function (state) local_methods.SetHasMoreAutoSpins (impl, state) end
  public_methods.SetNextSpinParams          = function (params) impl.next_spin_params = params end
  public_methods.SetPlayButtonHidden        = function (state) local_methods.SetPlayButtonHidden (impl, state) end 
  public_methods.SetSlotVisible             = function (state) SetSlotVisible (impl, state) end
  public_methods.SetUiState                 = function (state) SetUiState (impl, state) end
  public_methods.SetWinValue                = function (value, immediate) SetWinValue (impl, value, immediate) end
  public_methods.ShowPendingPrizesInBattle  = function () local_methods.ShowPendingPrizesInBattle (impl) end
  public_methods.ShowWinTable               = function (state) ShowWinTable (impl, state) end
  public_methods.StopWinAnimation           = function () StopWinAnimation (impl) end
  public_methods.Update                     = function () Update (impl) end
  public_methods.UpdateBalanceText          = function (value) UpdateBalanceText (impl, value) end

  SetUiState (impl, false)
  UpdateLinesButtonsState (impl)

  HsConnectionPopStoredMessages (SLOT_INIT_MESSAGE)

  local free_spins_gain = ApplicationDataGet (FREE_SPINS_GAIN)

  if free_spins_gain then
    SetUiState (impl, false)
    OnFreeSpinsGain (impl, free_spins_gain)
  end

  impl.ignore_bonus_win = true

  impl.boosters_overlay_resource_binding            = LoadResource ("data/res/materials/boosters_overlay_layers.xmtl")
  impl.boosters_overlay_compressed_resource_binding = LoadResource ("data/res/materials/boosters_overlay_compressed_layers.xmtl")

  PrepareAnimationScreenPart ("data/animations/boosters_overlay.xml", "boosters_overlay")
    
  if impl.battle_active then
    impl.shown_prizes = {}
  
    impl.battle_info_opponent_update_actions = {}
  
    game.scripts.top_ui.SetBackToLobbyButtonState (false)
  
    impl.battle_user_new_money      = 0
    impl.battle_user_money          = 0
    impl.battle_opponent_money      = 0
    impl.last_battle_user_money     = 0
    impl.last_battle_opponent_money = 0
    impl.player_progress_value      = 0
    impl.opponent_progress_value    = 0

    SetSpritesActive (true, impl.bet_less_button_disabled, impl.bet_more_button_disabled, 
                      impl.lines_less_button_disabled, impl.lines_more_button_disabled,
                      impl.payment_table_button_disabled, impl.all_lines_button_disabled)
    SetSpritesActive (false, impl.bet_less_button_enabled, impl.bet_more_button_enabled, 
                      impl.lines_less_button_enabled, impl.lines_more_button_enabled,
                      impl.payment_table_button_enabled, impl.all_lines_button_enabled)

    SetTextLinesActive (false, unpack (impl.payment_table_line_active))
    SetTextLinesActive (true, unpack (impl.payment_table_line_passive))

    if not impl.phone_ui then
      SetTextLinesActive (false, unpack (impl.all_lines_active_text))
      SetTextLinesActive (true, unpack (impl.all_lines_passive_text))
    end
    
    SetUiState (impl, false)
    
    impl.players_info = ApplicationDataGet (BATTLE_PLAYERS_INFO)
    
    local battle_mode = ApplicationDataGet (BATTLE_INIT_DATA).mode_id
    local battles     = GetBattles ()

    impl.battle_duration = 60
    impl.battle_type     = 0
    
    for i = 1, #battles do
      local modes = battles [i].modes
      
      for j = 1, #modes do
        local mode = modes [j]
        
        if mode.id == battle_mode then
          impl.battle_duration  = mode.time
          impl.battle_type      = mode.win_type
          impl.battle_win_money = mode.win_money
          break
        end
      end
    end

    impl.battle_overlay_suffix = ""
    
    if impl.phone_ui and impl.battle_type == 1 then
      impl.battle_overlay_suffix = "_ex"
    end

    local player_progress_bar   = GetSprite ("battle_overlay_player_first_progress_bar" .. impl.battle_overlay_suffix).layout
    local opponent_progress_bar = GetSprite ("battle_overlay_opponent_first_progress_bar" .. impl.battle_overlay_suffix).layout

    impl.battle_player_progress_scissor   = { left = player_progress_bar:Get ("Left"), width = player_progress_bar:Get ("Width") }
    impl.battle_opponent_progress_scissor = { left = opponent_progress_bar:Get ("Left"), width = opponent_progress_bar:Get ("Width") }

    ActivateSprites ("battle_overlay_background" .. impl.battle_overlay_suffix)
    ActivateTextLines ("battle_overlay_player_name" .. impl.battle_overlay_suffix, "battle_overlay_opponent_name" .. impl.battle_overlay_suffix, "battle_overlay_player_score" .. impl.battle_overlay_suffix, 
                       "battle_overlay_opponent_score" .. impl.battle_overlay_suffix, "battle_overlay_player_level" .. impl.battle_overlay_suffix, "battle_overlay_opponent_level" .. impl.battle_overlay_suffix)

    GetTextLine ("battle_overlay_player_name" .. impl.battle_overlay_suffix).node.Text    = impl.players_info.you.first_name 
    GetTextLine ("battle_overlay_opponent_name" .. impl.battle_overlay_suffix).node.Text  = impl.players_info.opponent.first_name 
    GetTextLine ("battle_overlay_player_level" .. impl.battle_overlay_suffix).node.Text   = tostring (impl.players_info.you.level) 
    GetTextLine ("battle_overlay_opponent_level" .. impl.battle_overlay_suffix).node.Text = tostring (impl.players_info.opponent.level)
    
    if impl.battle_type == 0 then
      ActivateSprite ("battle_overlay_timer_background")
      ActivateTextLine ("battle_overlay_timer")
    
      GetTextLine ("battle_overlay_timer").node.Text = tostring (impl.battle_duration) 

      local timer_frames = {}

      for i = 0, 58 do
        table.insert (timer_frames, "timer_" .. i .. ".png")
      end      

      impl.timer_animation = CreateAnimationSpriteClass ({ stay = { timer_frames [1] }, animate = timer_frames }, timer_frames [1], 60 / impl.battle_duration).CreateInstance (game.current_screen.scenes.top_ui.Root, "ui")

      local timer_position_sprite = GetSprite (timer_frames [1])
      local timer_position_layout = timer_position_sprite.layout

      impl.timer_animation.SetPosition (timer_position_layout:Get ("Left") + timer_position_layout:Get ("Width") / 2, -timer_position_layout:Get ("Top") - timer_position_layout:Get ("Height") / 2, timer_position_sprite.z)
      impl.timer_animation.Show ("stay")
    elseif impl.battle_type == 1 then
      ActivateSprite ("battle_overlay_score_background")
      ActivateTextLines ("battle_overlay_score_title", "battle_overlay_score_value")
    
      local score_symbols_count
    
      if impl.phone_ui then
        score_symbols_count = BATTLE_OVERLAY_SCORE_VALUE_PHONE_SYMBOLS_COUNT
      else
        score_symbols_count = BATTLE_OVERLAY_SCORE_VALUE_PAD_SYMBOLS_COUNT
      end

      GetTextLine ("battle_overlay_score_value").node.Text = FormatMoneyString (impl.battle_win_money, score_symbols_count, nil, true) 
    end

    ExecuteOnNextUpdate (function ()
      local you_avatar_sprite      = GetSprite ("battle_overlay_player_avatar" .. impl.battle_overlay_suffix)
      local opponent_avatar_sprite = GetSprite ("battle_overlay_opponent_avatar" .. impl.battle_overlay_suffix)
      local you_avatar_layout      = you_avatar_sprite.layout
      local opponent_avatar_layout = opponent_avatar_sprite.layout
      local you_avatar_size        = { x = you_avatar_layout:Get ("Width") + 0, y = you_avatar_layout:Get ("Height") + 0 }
      local opponent_avatar_size   = { x = opponent_avatar_layout:Get ("Width") + 0, y = opponent_avatar_layout:Get ("Height") + 0 }
      local camera                 = game.current_screen.cameras.top_ui_camera.node
      local screen_scale           = window_height / (camera.Top - camera.Bottom)

      impl.you_avatar = CreateUrlSprite (URL_SPRITE_MODE_CACHE_FILE, impl.players_info.you.photo, {}, 
                                         { material = you_avatar_sprite.node.Material, tex_size = StringToVec (you_avatar_sprite.layout:Get ("TexSize")), tex_offset = StringToVec (you_avatar_sprite.layout:Get ("TexOffset")) }, 
                                         you_avatar_size, you_avatar_size.x * PHOTO_ACTIVITY_INDICATOR_FACTOR, screen_scale)

      local avatar_sprite = impl.you_avatar.GetSprite ()

      avatar_sprite.Position = vec3 (you_avatar_layout:Get ("Left") + you_avatar_size.x / 2, -you_avatar_layout:Get ("Top") - you_avatar_size.y / 2, you_avatar_sprite.z - EPS)    

      avatar_sprite:BindToParent (game.current_screen.scenes.top_ui.Root)

      impl.you_avatar.OnShow ()

      impl.opponent_avatar = CreateUrlSprite (URL_SPRITE_MODE_CACHE_FILE, impl.players_info.opponent.photo, {}, 
                                              { material = opponent_avatar_sprite.node.Material, tex_size = StringToVec (opponent_avatar_sprite.layout:Get ("TexSize")), tex_offset = StringToVec (opponent_avatar_sprite.layout:Get ("TexOffset")) }, 
                                              opponent_avatar_size, opponent_avatar_size.x * PHOTO_ACTIVITY_INDICATOR_FACTOR, screen_scale)

      local avatar_sprite = impl.opponent_avatar.GetSprite ()

      avatar_sprite.Position = vec3 (opponent_avatar_layout:Get ("Left") + opponent_avatar_size.x / 2, -opponent_avatar_layout:Get ("Top") - opponent_avatar_size.y / 2, opponent_avatar_sprite.z - EPS)    

      avatar_sprite:BindToParent (game.current_screen.scenes.top_ui.Root)

      impl.opponent_avatar.OnShow ()
      
      ExecuteOnNextUpdate (function ()
        ExecuteOnNextUpdate (function ()
          HsConnectionSendMessage (1, { event = "battle.ready" })
        end)
      end)
    end)

    PlaySound ("battle_slot_shown")
    
    if ApplicationDataGet (BATTLE_INTERRUPTED) then
      OnBattleInterrupt (impl)
    end
  end

  OnSizeChanged (impl, window_width, window_height)

  OnSlotInit (impl, HsConnectionGetStoredResponse (SLOT_INIT_MESSAGE))

  local free_spins_allowed = true

  if impl.event_handler and impl.event_handler.IsFreeSpinsAllowed then
    free_spins_allowed = impl.event_handler.IsFreeSpinsAllowed ()
  end

  if impl.free_spins and impl.free_spins > 0 and free_spins_allowed then
    impl.free_spins_started = true
  end

  local slots_descs = ApplicationDataGet (SLOTS_DESCS) 
  
  for i = 1, #slots_descs do
    local slot_desc = slots_descs [i]
  
    if slot_desc.id and slot_desc.id + 0 == impl.slot_id + 0 then
      impl.hs_path = slot_desc.hs_path
      break
    end
  end

  if ApplicationDataGet (BONUS_GAME_COMPLETED) then
    ApplicationDataSet (BONUS_GAME_COMPLETED, nil)
  
    local bonus_item = impl.items [impl.items_list [1]]

    game.scripts.ui_windows.ShowBonusEndedWindow (GetLocalizedString (string.format ("BONUS_GAME_NAME.%s", impl.bonus_screen)), bonus_item.material, bonus_item.tex_size, bonus_item.tex_offset, bonus_item.scale, GetVarValue (game.current_screen.vars, 'share_symbol_hs_path') or impl.hs_path)
    
    ExecuteOnNextUpdate (PauseGame)
  end

  if GetHsPort () ~= HS_LIVE_PORT then
    public_methods.DebugRequestFreeSpins = function () 
      HsConnectionSendMessage (1, { event = "debug.freeSpin", slotId = impl.slot_id, freeSpinsCount = 5 }) 
    end
    public_methods.DebugResetFreeSpins = function () 
      HsConnectionSendMessage (1, { event = "debug.freeSpin", slotId = impl.slot_id, freeSpinsCount = 0 }) 
    end
    public_methods.DebugShowFiveInRow = function ()
      impl.five_in_row_payout = 10000
     
      ShowFiveInRowWindow (impl, 5)
    end
    public_methods.DebugShowBonusFinish = function () 
      local bonus_item = impl.items [impl.items_list [1]]

      ApplicationDataSet (BONUS_GAME_MONEY, 100000)

      game.scripts.ui_windows.ShowBonusEndedWindow (GetLocalizedString (string.format ("BONUS_GAME_NAME.%s", impl.bonus_screen)), bonus_item.material, bonus_item.tex_size, bonus_item.tex_offset, bonus_item.scale, GetVarValue (game.current_screen.vars, 'share_symbol_hs_path') or impl.hs_path)
    end
    public_methods.DebugShowFreeSpinsWin = function ()
      if impl.phone_ui then
        SetUiState (impl, false)
      end
    
      impl.total_free_spins_payout = math.random (100) * 1000000
      impl.total_free_spins_count  = math.random (20)
      impl.free_spins_win_count_text_line.node.Text  = tostring (impl.total_free_spins_count)
      impl.free_spins_win_payout_text_line.node.Text = FormatMoneyString (impl.total_free_spins_payout, impl.free_spins_payout_max_digits_count, nil, true)
      ShowFreeSpinsResults (impl)     
    end
    public_methods.DebugShowFreeSpinsLoose = function () 
      if impl.phone_ui then
        SetUiState (impl, false)
      end
    
      impl.total_free_spins_payout = 0
      impl.total_free_spins_count  = math.random (20)
      ShowFreeSpinsResults (impl)     
    end
    public_methods.DebugShowAllLines = function ()
      local wins_table = { wins = {}, totalPayout = 0, bonus = false, freeSpins = 0 }
      
      for i = 1, math.min (#LINES_SYMBOLS, #impl.lines) do
        table.insert (wins_table.wins, { type = 1, line = i, payout = 100, symbols = LINES_SYMBOLS [i] })
      end
      
      local wins_event = Common.StringNode.LoadJsonFromString (JsonCoder.encode (wins_table))
     
      ParseWins (impl, wins_event)
      
      AnimateAllWinLines (impl)
      ShowWinTable (impl, true)
    end
    public_methods.DebugShowNewLevel = function ()
      ShowLevelUpWindow (impl) 
    end
    public_methods.DebugShowAllAchievements = function ()
      OnAchievementComplete (impl, { id = 0, group_id = 1, current = 1, prize_type = 0 })
      OnAchievementComplete (impl, { id = 1, group_id = 1, current = 1, prize_type = 0 })
      OnAchievementComplete (impl, { id = 2, group_id = 1, current = 500, prize_type = 0 })
      OnAchievementComplete (impl, { id = 3, group_id = 1, current = 5, prize_type = 0 })
      OnAchievementComplete (impl, { id = 4, group_id = 1, current = 20, prize_type = 0 })
      OnAchievementGroupComplete (impl, { id = 1, prize = 5000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 5, group_id = 2, current = 16, prize_type = 0 })
      OnAchievementComplete (impl, { id = 6, group_id = 2, current = 10, prize_type = 0 })
      OnAchievementComplete (impl, { id = 7, group_id = 2, current = 300, prize_type = 0 })
      OnAchievementComplete (impl, { id = 8, group_id = 2, current = 300, prize_type = 0 })
      OnAchievementComplete (impl, { id = 9, group_id = 2, current = 50, prize_type = 0 })
      OnAchievementGroupComplete (impl, { id = 2, prize = 10000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 10, group_id = 3, current = 10, prize_type = 0 })
      OnAchievementComplete (impl, { id = 11, group_id = 3, current = 10, prize_type = 0 })
      OnAchievementComplete (impl, { id = 12, group_id = 3, current = 10, prize_type = 0 })
      OnAchievementComplete (impl, { id = 13, group_id = 3, current = 1, prize_type = 0 })
      OnAchievementComplete (impl, { id = 14, group_id = 3, current = 1, prize_type = 0 })
      OnAchievementGroupComplete (impl, { id = 3, prize = 50000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 15, group_id = 4, current = 200, prize_type = 0 })
      OnAchievementComplete (impl, { id = 16, group_id = 4, current = 50000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 17, group_id = 4, current = 100000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 18, group_id = 4, current = 50000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 19, group_id = 4, current = 300000000, prize_type = 0 })
      OnAchievementGroupComplete (impl, { id = 4, prize = 100000000, prize_type = 0 })
      OnAchievementComplete (impl, { id = 22, group_id = 5, current = 387, prize_type = 1 })
      OnAchievementComplete (impl, { id = 23, group_id = 5, current = 750, prize_type = 1 })
      OnAchievementComplete (impl, { id = 24, group_id = 5, current = 10, prize_type = 1 })
      OnAchievementComplete (impl, { id = 25, group_id = 5, current = 100, prize_type = 1 })
      OnAchievementComplete (impl, { id = 26, group_id = 5, current = 1, prize_type = 1 })
      OnAchievementGroupComplete (impl, { id = 5, prize = 2000, prize_type = 1 })
    end
    public_methods.DebugShowTopNotifications = function ()
      local_methods.OnTopNotification (impl, { place = 90, top_type = 0, top_stage = 2 })
      local_methods.OnTopNotification (impl, { place = 9, top_type = 1, top_stage = 2 })
      local_methods.OnTopNotification (impl, { place = 3, top_type = 2, top_stage = 2 })
      local_methods.OnTopNotification (impl, { place = 2, top_type = 0, top_stage = 2 })
      local_methods.OnTopNotification (impl, { place = 1, top_type = 1, top_stage = 2 })
    end
    public_methods.DebugShowPrizes = function ()
      impl.debug_window = impl.debug_window or 0

      local debug_window_functions = {
        function ()
          game.scripts.ui_windows.ShowWelcomeWindow (10000, 10)
        end,
        function ()
          OnAchievementComplete (impl, { id = 0, group_id = 1, current = 1, prize_type = 0 })
          OnAchievementComplete (impl, { id = 22, group_id = 5, current = 387, prize_type = 1 })
        end,
        function ()
          OnAchievementGroupComplete (impl, { id = 1, prize = 5000000, prize_type = 0 })
          OnAchievementGroupComplete (impl, { id = 5, prize = 2000, prize_type = 1 })
        end,
        function ()
          game.scripts.ui_windows.ShowHelloCombinedWindow (10, 20000, 30)
        end,
        function ()
          game.scripts.ui_windows.ShowInfoWindowDataTransferWindow ()
        end,
        function ()
          game.scripts.ui_windows.ShowNoMoneyWindow ()
        end,
        function ()
          game.scripts.ui_windows.ShowNotEnoughMoneyWindow ()
        end,
        function ()
          game.scripts.ui_windows.ShowWinnerOfBestPlayerWindow (1, 1, 1, 1000)
        end,
        function ()
          game.scripts.ui_windows.ShowWinnerOfBestPlayerWindow (2, 2, 2, 1000)
        end,
        function ()
          game.scripts.ui_windows.ShowWinnerOfBestPlayerWindow (3, 0, 1, 1000)
        end,
        function ()
          game.scripts.ui_windows.ShowBattleLoseWindow (true)
        end,
        function ()
          game.scripts.ui_windows.ShowBattleDrawWindow (10000, true)
        end,
        function ()
          game.scripts.ui_windows.ShowBattleWinWindow (10000, 10, false, true)
        end,
        function ()
          game.scripts.ui_windows.ShowBattleInviteWindow (1, { user_id = 1, first_name = "First", last_name = "Last", rating = 1000, wins = 500, loses = 300, level = 400, photo = "https://pp.vk.me/c306610/u93339557/a_fa2e2549.jpg" }, true)
        end,
        function ()
          game.scripts.ui_windows.ShowNotHaveCoinsEnoughForBattleWindow (function () end)
        end,
        function ()
          game.scripts.ui_windows.ShowNoDiamondWindow ()
        end,
        function ()
          game.scripts.ui_windows.ShowNewGameWindow (4)
        end,
        function ()
          game.scripts.ui_windows.ShowBonusByLevelWindow (100, 150)
        end
      }     
    
      impl.debug_window = (impl.debug_window % #debug_window_functions) + 1

      debug_window_functions [impl.debug_window] ()
    end
  end

  ApplicationDataSet (BATTLE_INVITE_DATA, nil)

  StopMusic ()

  if not impl.battle_active then
    ExecuteOnNextUpdate (ShowPendingAchievementsCompleteWindows)
  end

  local tutorials = GetTutorials ()
  
  impl.spin_tutorial_completed = false
  
  for i = 1, #tutorials do
    if tutorials [i] + 0 == 2 then
      impl.spin_tutorial_completed = true
      break
    end
  end
  
  if not impl.spin_tutorial_completed then
    ExecuteOnNextUpdate (function ()
      game.scripts.top_ui.SetPlayArrowHelperVisible (true)
    end)
  end

  local OnLostScreenMethod = public_methods.OnLostScreen

  ExecuteOnNextUpdate (function ()
    if OnLostScreenMethod ~= public_methods.OnLostScreen then
      impl.overrided_on_lost_screen = public_methods.OnLostScreen
      public_methods.OnLostScreen = OnLostScreenMethod
    end 
  end)

  return public_methods
end
