local CURRENT_TOKEN_VERSION = 21

local DEV_APP_ID  = "432521326807729"
local QA_APP_ID   = "307913135974149"
local LIVE_APP_ID = "357943580965557"

local DEV_APP_URL  = "https://apps.facebook.com/play-slots_dev/"
local QA_APP_URL   = "https://apps.facebook.com/play-slots_qa/"
local LIVE_APP_URL = "https://apps.facebook.com/play-slots/"

local DEV_ASSETS_SERVER_URL  = "http://plarium.vo.llnwd.net/v1/slots/live1"
local QA_ASSETS_SERVER_URL   = "http://plarium.vo.llnwd.net/v1/slots/live1"
local LIVE_ASSETS_SERVER_URL = "http://plarium.vo.llnwd.net/v1/slots/live1"

local SHARE_NEW_LEVEL_IMAGE          = "/assets/image/post/levels/level_cleared.jpg"
local SHARE_FIVE_IN_ROW_IMAGE        = "/games/%s/image/post/symbol_%d.png"
local SHARE_BONUS_GAME_IMAGE         = "/games/%s/image/post/symbol_0.png"
local SHARE_MEGA_BONUS_IMAGE         = "/assets/image/post/fb/mega_bonus_finish.jpg"
local SHARE_ACHIEVEMENTS_GROUP_IMAGE = "/assets/image/post/achiev/achiev_main.png"
local SHARE_BATTLE_WIN_IMAGE         = "/assets/image/post/fb/battles_winner.jpg"
local SHARE_TOP_1_IMAGE              = "/assets/image/post/fb/top/top_1.jpg"
local SHARE_TOP_2_IMAGE              = "/assets/image/post/fb/top/top_2.jpg"
local SHARE_TOP_3_IMAGE              = "/assets/image/post/fb/top/top_3.jpg"
local SHARE_TOP_10_IMAGE             = "/assets/image/post/fb/top/top_10.jpg"
local SHARE_TOP_100_IMAGE            = "/assets/image/post/fb/top/top_100.jpg"

local SHARE_ACHIEVEMENT_IMAGE = {
  "/assets/image/post/achiev/achiev_0.png",
  "/assets/image/post/achiev/achiev_1.png",
  "/assets/image/post/achiev/achiev_2.png",
  "/assets/image/post/achiev/achiev_3.png",
  "/assets/image/post/achiev/achiev_4.png",
  "/assets/image/post/achiev/achiev_5.png",
  "/assets/image/post/achiev/achiev_6.png",
  "/assets/image/post/achiev/achiev_7.png",
  "/assets/image/post/achiev/achiev_8.png",
  "/assets/image/post/achiev/achiev_9.png",
  "/assets/image/post/achiev/achiev_10.png",
  "/assets/image/post/achiev/achiev_11.png",
  "/assets/image/post/achiev/achiev_12.png",
  "/assets/image/post/achiev/achiev_13.png",
  "/assets/image/post/achiev/achiev_14.png",
  "/assets/image/post/achiev/achiev_15.png",
  "/assets/image/post/achiev/achiev_16.png",
  "/assets/image/post/achiev/achiev_17.png",
  "/assets/image/post/achiev/achiev_18.png",
  "/assets/image/post/achiev/achiev_19.png",
  "/assets/image/post/achiev/achiev_20.png",
  "/assets/image/post/achiev/achiev_21.png",
  "/assets/image/post/achiev/achiev_22.png",
  "/assets/image/post/achiev/achiev_23.png",
  "/assets/image/post/achiev/achiev_24.png",
  "/assets/image/post/achiev/achiev_25.png",
  "/assets/image/post/achiev/achiev_26.png"
}

local SHARE_LEADER_WIN_IMAGE = {
  "/assets/image/post/fb/leader_1st.jpg",
  "/assets/image/post/fb/leader_2nd.jpg",
  "/assets/image/post/fb/leader_3rd.jpg"
}

local NETWORK_NAME = "FB"

local function GetAppId ()
  return LIVE_APP_ID
end

local function GetAppUrl ()
  return LIVE_APP_URL
end

local function GetAssetServerUrl ()
  return LIVE_ASSETS_SERVER_URL
end

local function Logout (impl, on_logout_handler)
  impl.uid          = nil
  impl.token        = nil
  impl.user_info    = nil
  impl.is_logged_in = false

  if not impl.session then
    impl.session = Social.Session.Create ("Facebook")
  end

  impl.session:LogOut ()
  impl.session = nil

  collectgarbage ("collect")

  SetProfileProperty (FACEBOOK_LOGIN_ID_ATTRIBUTE, nil)
  SetProfileProperty (FACEBOOK_LOGIN_TOKEN_ATTRIBUTE, nil)
  
  if on_logout_handler then
    on_logout_handler ()
  end
end

local function OnFacebookRequestFailed (impl)
  if game.scripts.ui_windows then
    game.scripts.ui_windows.ShowAlertWindow (ALERT_TYPE_ERROR, function ()
      HsConnectionPopStoredMessages (AUTH_MESSAGE)
      HsConnectionReconnect ()              
      end, nil, GetLocalizedString ("RECONNECT"), { GetLocalizedString ("CONNECTION_ERROR") })
  else
    Logout (impl, function ()
      SetCurrentScreen ("main_menu")
    end)
  end
end

local function CancelLogin (impl)
  impl.session = nil

  collectgarbage ("collect")
end

local function GetNetworkName (impl)
  return NETWORK_NAME
end

local function Login (impl, on_login_handler, on_cancel_handler)
  System.Application.PostNotification ("LocalNotifications RemoveAll|SocialLogin")
  LogFlurryEvent ("SocialLogIn", { NetworkName = GetNetworkName () })  

  if impl.session then
    Logout (impl, function ()
      Login (impl, on_login_handler, on_cancel_handler)
    end)
    
    return
  end
  
  impl.is_logged_in = false

  impl.session = Social.Session.Create ("Facebook")

  local login_properties = Common.PropertyMap.Create ()

  login_properties:SetString ("AppId", GetAppId ());
  login_properties:SetString ("Permissions", "user_friends");
  
  local url_scheme_suffix = "live"
  
  url_scheme_suffix = url_scheme_suffix .. GetPlatform ()
  
  login_properties:SetString ("UrlSchemeSuffix", url_scheme_suffix);

  local saved_token = GetProfileProperty (FACEBOOK_LOGIN_TOKEN_ATTRIBUTE)
  
  local token_version = GetProfileProperty (FACEBOOK_TOKEN_VERSION) or 0

  token_version = token_version + 0
  
  if saved_token and token_version >= CURRENT_TOKEN_VERSION then
    login_properties:SetString ("Token", saved_token)

    local saved_uid = GetProfileProperty (FACEBOOK_LOGIN_ID_ATTRIBUTE)

    if saved_uid then
      login_properties:SetString ("UserId", saved_uid)
    end
  end

  impl.session:LogIn (Social.Session.CreateLoadCallback (function (dummy, status, error)
      if DEBUG then
        print ("Login status is " .. tostring (status))
      end      
        
      if status == Social.OperationStatus.Success then
        local current_user = impl.session.CurrentUser
      
        impl.uid   = current_user.Id
        impl.token = current_user.Properties:GetString ("Token")

        SetProfileProperty (FACEBOOK_LOGIN_ID_ATTRIBUTE, impl.uid)
        SetProfileProperty (FACEBOOK_LOGIN_TOKEN_ATTRIBUTE, impl.token)
        SetProfileProperty (FACEBOOK_TOKEN_VERSION, CURRENT_TOKEN_VERSION)
      
        if saved_token and token_version < CURRENT_TOKEN_VERSION then
          ExecuteOnNextUpdate (function ()
            Logout (impl, function ()
              ExecuteOnNextUpdate (function ()
                Login (impl, on_login_handler, on_cancel_handler)
              end, true)
            end) 
          end, true)

          return
        end

        impl.is_logged_in = true

        on_login_handler ()
      elseif status == Social.OperationStatus.Failure then
        print ("Login error = " .. tostring (error))
        
        game.scripts.ui_windows.ShowAlertWindow (ALERT_TYPE_ERROR, function ()
          CancelLogin (impl)
          on_cancel_handler ()
        end, nil, GetLocalizedString ("OK"), { GetLocalizedString ("LOGIN_ERROR_LINE_1"), GetLocalizedString ("LOGIN_ERROR_LINE_2"), GetLocalizedString ("LOGIN_ERROR_LINE_3"), GetLocalizedString ("LOGIN_ERROR_LINE_4"), GetLocalizedString ("LOGIN_ERROR_LINE_5") })
      else
        CancelLogin (impl)
        on_cancel_handler ()
      end 
    end), login_properties)
end

local function GetStringProperty (properties, name, default_value)
  if not properties:IsPresent (name) then 
    return default_value
  end
  
  return properties:GetString (name) 
end

local function GetIntProperty (properties, name, default_value)
  if not properties:IsPresent (name) then 
    return default_value
  end
  
  return properties:GetInteger (name) 
end

local function LoadUserInfo (impl, handler)
  if not impl.session then
    error ("Can't get user info, not logged in")
  end

  if impl.user_info then
    if handler then
      handler ()
    end
    
    return
  end
  
  local load_user_properties = Common.PropertyMap.Create ()
  
  load_user_properties:SetString ("Fields", "first_name,last_name,picture.type(large),gender")
  
  impl.session:LoadUser (impl.session.CurrentUser.Id, Social.Session.CreateLoadCallback (function (dummy, status, error)
      if DEBUG then
        print ("Load user status is " .. tostring (status))
      end      
        
      if status == Social.OperationStatus.Success then
        impl.user_info = {}
        
        impl.user_info.friends = {}

        local user            = dummy
        local user_properties = user.Properties
        
        impl.user_info.first_name = GetStringProperty (user_properties, "first_name", "")  
        impl.user_info.last_name  = GetStringProperty (user_properties, "last_name", "")  
        impl.user_info.photo      = GetStringProperty (user_properties, "picture", nil) 
        
        impl.user_info.is_facebook_app_installed = GetIntProperty (impl.session.CurrentUser.Properties, "IsFacebookAppInstalled", 0) ~= 0

        local sex = GetStringProperty (user_properties, "gender", nil)
        
        if sex then
          if sex == "male" then
            impl.user_info.sex = 1
          elseif sex == "female" then
            impl.user_info.sex = 0
          end 
        end

        local load_friends_properties = Common.PropertyMap.Create ()

        load_friends_properties:SetString ("Fields", "first_name,last_name,picture.type(large)")

        impl.session:LoadFriends (impl.session.CurrentUser, Social.Session.CreateLoadCallback (function (dummy, status, error)
          if DEBUG then
            print ("Load friends status is " .. tostring (status))
          end      
        
          if status == Social.OperationStatus.Success then
            local friends = dummy
            
            for i = 0, friends.Size - 1 do
              local friend_desc       = friends:Get (i)
              local friend_properties = friend_desc.Properties
              local friend            = {}
            
              friend.uid        = friend_desc.Id
              friend.first_name = GetStringProperty (friend_properties, "first_name", "")  
              friend.last_name  = GetStringProperty (friend_properties, "last_name", "")  
              friend.photo      = GetStringProperty (friend_properties, "picture", "")  

              table.insert (impl.user_info.friends, friend)
            end
          
            local load_invitable_friends_properties = Common.PropertyMap.Create ()
 
            load_invitable_friends_properties:SetString ("fields", "first_name,last_name,picture.type(large)")

            impl.session:PerformRequest ("me/invitable_friends", Social.Session.CreateRequestCallback (function (response, status, error)
              if DEBUG then
                print ("Load invitable friends status is " .. tostring (status))
              end      
        
              if status == Social.OperationStatus.Success then
                local friends = Common.StringNode.LoadJsonFromString (response):Find ("data"):Child (0)

                for i = 0, friends.ChildrenCount - 1 do
                  local friend_desc = friends:Child (i)
                  local friend      = {}

                  friend.uid        = GetNodeChildAttribute (friend_desc, "id")
                  friend.first_name = GetNodeChildAttribute (friend_desc, "first_name", "")  
                  friend.last_name  = GetNodeChildAttribute (friend_desc, "last_name", "")
                  
                  local picture = friend_desc:Find ("picture"):Child (0):Find ("data"):Child (0)  
                  
                  friend.photo = GetNodeChildAttribute (picture, "url", "")  
 
                  table.insert (impl.user_info.friends, friend)
                end

                handler ()
              else
                OnFacebookRequestFailed (impl)
              end 
            end), load_invitable_friends_properties)
          else
            OnFacebookRequestFailed (impl)
          end 
        end), load_friends_properties)
      else
        OnFacebookRequestFailed (impl)
      end 
    end), load_user_properties)
end

local function GetFirstName (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.user_info.first_name
end

local function GetLastName (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.user_info.last_name
end

local function GetFriends (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.user_info.friends
end

local function GetPhoto (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.user_info.photo
end

local function GetUserGender (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.user_info.sex
end

local function GetUserId (impl)
  if not impl.user_info then
    error ("User info not obtained")
  end
  
  return impl.uid
end

local function GetUserInfo (impl)
  return impl.user_info
end

local function IsLoggedIn (impl)
  return impl.is_logged_in
end

local function ShowInviteFriendsWindow (impl) 
  if not impl.session then
    error ("User is not logged in")
  end
  
  local invite_properties = Common.PropertyMap.Create ()
  
  invite_properties:SetString ("message", GetLocalizedString ("INVITE_FRIEND_MESSAGE_FACEBOOK"))
  
  game.scripts.ui_windows.ShowAlertWindow (nil, nil, nil, nil, { GetLocalizedString ("FRIENDS_INVITE_IN_PROGRESS") }, true)

  impl.session:ShowWindow ("apprequests", Social.Session.CreateLoadCallback (function (dummy, status, error)
      if DEBUG then
        print ("Invite friends status is " .. tostring (status) .. " error is " .. error)
      end      
        
      if status == Social.OperationStatus.Success then
        game.scripts.ui_windows.ShowAlertWindow (nil, nil, function () end, nil, { GetLocalizedString ("FRIENDS_INVITED") }, nil, nil, true)
        
        local request      = GetRequestParam (error, "request")
        local friends_list = {}
        
        for i = 0, 9999 do
          local login_id = GetRequestParam (error, "to[" .. i .. "]")
          
          if not login_id then break end
          
          table.insert (friends_list, login_id)  
        end

        HsReportFriendsInvited (request, friends_list)
      elseif status == Social.OperationStatus.Failure then
        print ("Invite friends error = " .. tostring (error))
        game.scripts.ui_windows.ShowAlertWindow (ALERT_TYPE_ERROR, function ()
        end, nil, GetLocalizedString ("CLOSE"), { GetLocalizedString ("CONNECTION_ERROR") })
      else
        game.scripts.ui_windows.HideWindow ()
      end 
    end), invite_properties)  
end

local function ShareChips (impl, message, share_type, share_id, handler, description, additional_info, on_cancel_handler)
  local url

  if share_type == SHARE_BATTLE_WIN_TYPE then
    url = GetAppUrl ()
  else
    url = GetAppUrl () .. "?post_id=" .. share_id .. "%26poster_id=" .. impl.uid
  end
  
  local share_image

  if share_type == SHARE_NEW_LEVEL_TYPE then
    share_image = SHARE_NEW_LEVEL_IMAGE
  elseif share_type == SHARE_FIVE_IN_ROW_TYPE then
    share_image = string.format (SHARE_FIVE_IN_ROW_IMAGE, additional_info.hs_path, additional_info.symbol_id)
  elseif share_type == SHARE_BONUS_GAME_TYPE then
    share_image = string.format (SHARE_BONUS_GAME_IMAGE, additional_info.hs_path)
  elseif share_type == SHARE_MEGA_BONUS_TYPE then
    share_image = SHARE_MEGA_BONUS_IMAGE
  elseif share_type == SHARE_ACHIEVEMENT_COINS_TYPE or share_type == SHARE_ACHIEVEMENT_DIAMONDS_TYPE then
    share_image = SHARE_ACHIEVEMENT_IMAGE [additional_info + 1]
  elseif share_type == SHARE_ACHIEVEMENTS_GROUP_COINS_TYPE or share_type == SHARE_ACHIEVEMENTS_GROUP_DIAMONDS_TYPE then
    share_image = SHARE_ACHIEVEMENTS_GROUP_IMAGE
  elseif share_type == SHARE_BATTLE_WIN_TYPE then
    share_image = SHARE_BATTLE_WIN_IMAGE
  elseif share_type == SHARE_LEADER_WIN_COINS_TYPE or share_type == SHARE_LEADER_WIN_DIAMONDS_TYPE then
    share_image = SHARE_LEADER_WIN_IMAGE [additional_info]
  elseif share_type == SHARE_TOP_COINS_100_TYPE or share_type == SHARE_TOP_COINS_10_TYPE or share_type == SHARE_TOP_COINS_1_TYPE or
         share_type == SHARE_TOP_DIAMONDS_100_TYPE or share_type == SHARE_TOP_DIAMONDS_10_TYPE or share_type == SHARE_TOP_DIAMONDS_1_TYPE then
    if additional_info == 1 then
      share_image = SHARE_TOP_1_IMAGE
    elseif additional_info == 2 then
      share_image = SHARE_TOP_2_IMAGE
    elseif additional_info == 3 then
      share_image = SHARE_TOP_3_IMAGE
    elseif additional_info < 11 then
      share_image = SHARE_TOP_10_IMAGE
    else
      share_image = SHARE_TOP_100_IMAGE
    end
  else
    error ("Unknown share type " .. tostring (share_type))
  end

  print ("share image = '" .. share_image .. "'")

  local share_properties = Common.PropertyMap.Create ()
  
  share_properties:SetString ("name", message)
  
  if url then
    share_properties:SetString ("link", url)
  end
  
  share_properties:SetString ("picture", GetAssetServerUrl () .. share_image)
  
  if description then
    share_properties:SetString ("description", description)
  end
  
  impl.session:ShowWindow ("feed", Social.Session.CreateLoadCallback (function (dummy, status, error)
      if DEBUG then
        print ("Share status is " .. tostring (status))
      end      
        
      if status == Social.OperationStatus.Success then
        handler ()
      elseif status == Social.OperationStatus.Failure then
        print ("Share error = " .. tostring (error))
        game.scripts.ui_windows.ShowAlertWindow (ALERT_TYPE_ERROR, function ()
        end, nil, GetLocalizedString ("CLOSE"), { GetLocalizedString ("CONNECTION_ERROR") })
      else
        game.scripts.ui_windows.HideWindow ()
        
        if on_cancel_handler then
          on_cancel_handler ()
        end
      end 
    end), share_properties)  
end

local function FillAuthMessage (impl, message)
  message.lastName  = GetLastName (impl)
  message.firstName = GetFirstName (impl)
  message.token     = impl.token
  message.photo     = GetPhoto (impl)
  message.network   = NETWORK_NAME
  message.loginId   = impl.uid
  message.sex       = impl.user_info.sex
  message.birthday  = impl.user_info.birthday
    
  local friends = {}
    
  for i = 1, #impl.user_info.friends do
    table.insert (friends, impl.user_info.friends [i].uid)
  end
    
  message.friends = friends
end

function CreateSocialFacebookEngine ()
  local impl = {}
 
  local public_methods = {}

  public_methods.FillAuthMessage         = function (message) FillAuthMessage (impl, message) end
  public_methods.GetFirstName            = function () return GetFirstName (impl) end
  public_methods.GetFriends              = function () return GetFriends (impl) end
  public_methods.GetLastName             = function () return GetLastName (impl) end
  public_methods.GetNetworkName          = function () return GetNetworkName (impl) end
  public_methods.GetPhoto                = function () return GetPhoto (impl) end
  public_methods.GetUserGender           = function () return GetUserGender (impl) end
  public_methods.GetUserId               = function () return GetUserId (impl) end
  public_methods.GetUserInfo             = function () return GetUserInfo (impl) end
  public_methods.LoadUserInfo            = function (handler) LoadUserInfo (impl, handler) end
  public_methods.HasInviteFriendsWindow  = function () return true end
  public_methods.IsLoggedIn              = function () return IsLoggedIn (impl) end
  public_methods.Login                   = function (login_handler, cancel_handler) Login (impl, login_handler, cancel_handler) end
  public_methods.Logout                  = function (handler) Logout (impl, handler) end
  public_methods.ShowInviteFriendsWindow = function () ShowInviteFriendsWindow (impl) end
  public_methods.ShareChips              = function (message, share_type, share_id, handler, description, additional_info, on_cancel_handler) ShareChips (impl, message, share_type, share_id, handler, description, additional_info, on_cancel_handler) end    
    
  return public_methods
end

